import { K8sApiJsonSchema } from 'k8s-super-client/dist/open-api/converter/types';
import { ILogger } from 'the-logger';
import { K8sClusterConnector } from '../k8s-connector/k8s-cluster-connector';
export declare class K8sApiSchemaFetcher {
    private _logger;
    constructor(logger: ILogger);
    fetchRemote(k8sConnector: K8sClusterConnector): Promise<K8sApiSchemaFetcherResult>;
    fetchLocal(targetVersion?: string | null): Promise<K8sApiSchemaFetcherResult>;
}
export interface K8sApiSchemaFetcherResult {
    success: boolean;
    error?: string;
    targetVersion: string | null;
    selectedVersion: string | null;
    found: boolean;
    foundExact: boolean;
    k8sJsonSchema: K8sApiJsonSchema | null;
}
//# sourceMappingURL=k8s-api-schema-fetcher.d.ts.map