"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.formatResult = void 0;
const logger_1 = require("../../logger");
const counters_1 = require("../../manifests/counters");
const myLogger = logger_1.logger.sublogger('GuardFormat');
function formatResult({ severity, manifestPackage, k8sSchemaInfo, rulesRuntime, lintResult, rulesResult, }) {
    myLogger.info("Severity:  %s", severity);
    myLogger.info("LintResult Severity:  %s", lintResult.severity);
    myLogger.info("LintResult Success: %s", lintResult.success);
    myLogger.info("RulesResult Severity:  %s", rulesResult.severity);
    myLogger.info("RulesResult Success: %s", rulesResult.success);
    const success = (severity == 'pass') || (severity == 'warning');
    const result = {
        success: success,
        severity: severity,
        lintResult: lintResult,
        rules: rulesResult,
        counters: (0, counters_1.calculateRuleEngineCounters)(rulesResult, manifestPackage)
    };
    logger_1.logger.verbose("RULES RESULT: ", rulesResult);
    logger_1.logger.info("RULE COUNTERS: ", result.counters);
    return result;
}
exports.formatResult = formatResult;
//# sourceMappingURL=format.js.map