"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const command_action_1 = require("../../infra/command-action");
const command_1 = require("./command");
const format_1 = require("./format");
const output_1 = require("./output");
const docs_1 = require("./docs");
const docs_2 = require("../lint/docs");
function default_1(program) {
    program
        .command('guard')
        .summary(docs_1.SUMMARY)
        .description(docs_1.DESCRIPTION)
        .argument('[path...]', docs_2.ARG_PATH)
        .option('--ignore-unknown', docs_2.OPTION_IGNORE_UNKNOWN)
        .option('--ignore-non-k8s', docs_2.OPTION_IGNORE_NON_K8S)
        .option('--skip-apply-crds', docs_2.OPTION_SKIP_APPLY_CRDS)
        .option('--stream', docs_2.OPTION_STREAM)
        .option('--k8s-version <version>', docs_2.OPTION_K8S_VERSION)
        .option('--live-k8s', docs_2.OPTION_LIVE_K8S)
        .option('--kubeconfig <path>', docs_2.OPTION_KUBECONFIG)
        .option('--k8s-skip-tls-verify', docs_2.OPTION_K8S_SKIP_TLS_VERIFY)
        .option('--include-remote-targets', 'Include remote Kubernetes manifests in target rules. Use with --live-k8s option.')
        .option('--skip-local-rules', 'Skip validation of rules passed to the CLI.')
        .option('--skip-remote-rules', 'Skip validation of rules that are already in the K8s cluster. Only used wth --live-k8s flag.')
        .option('--namespace <namespace>', 'Optionally specify namespace to process.')
        .option('--namespaces [namespace...]', 'Or specify multiple namespaces to process.')
        .option('--skip-cluster-scope', 'Skip processing clustered manifests and rules.')
        .option('--skip-community-rules', 'Skip community rules library.')
        .option('--skip-rules [name...]', 'Rules to skip.')
        .option('--only-rules [name...]', 'Names of rules to process.')
        .option('--skip-rule-categories [name...]', 'Rule categories to skip.')
        .option('--only-rule-categories [name...]', 'Rule categorie to process.')
        .option('--gitignore <path>', docs_2.OPTION_IGNORE_FILE)
        .option('--ignore-patterns [patterns...]', docs_2.OPTION_IGNORE_PATTERNS)
        .option('--detailed', docs_2.OPTION_DETAILED)
        .option('--json', docs_2.OPTION_JSON)
        .action(new command_action_1.CommandBuilder()
        .perform((path, options) => __awaiter(this, void 0, void 0, function* () {
        const myOptions = (0, command_1.massageGuardOptions)(options);
        return (0, command_1.command)(path, myOptions);
    }))
        .format(format_1.formatResult)
        .output(output_1.output)
        .decideSuccess(result => {
        if (!result.success) {
            return 100;
        }
        return 0;
    })
        .build());
}
exports.default = default_1;
//# sourceMappingURL=index.js.map