"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const command_action_1 = require("../../infra/command-action");
const command_1 = require("./command");
const format_1 = require("./format");
const output_1 = require("./output");
function default_1(program) {
    program
        .command('index-library')
        .description('Generate index for rules library repository. Creates index.yaml file.')
        .argument('<dir>', 'Path to the repository which contiains Kubevious rules.')
        .option('--name <name>', 'Library name.')
        .option('--json', 'Output command result in JSON.')
        .action(new command_action_1.CommandBuilder()
        .perform((dir, options) => __awaiter(this, void 0, void 0, function* () {
        const myOptions = (0, command_1.massageIndexOptions)(options);
        return (0, command_1.command)(dir, myOptions);
    }))
        .format(format_1.formatResult)
        .output(output_1.output)
        .decideSuccess(result => {
        if (!result.success) {
            return 100;
        }
        return 0;
    })
        .build());
}
exports.default = default_1;
//# sourceMappingURL=index.js.map