"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.output = void 0;
const screen_1 = require("../../screen");
const output_1 = require("../guard/output");
function output(result) {
    (0, output_1.output)(result.guardResult);
    (0, screen_1.print)();
    (0, screen_1.printSubTitle)('Rule Library');
    (0, screen_1.print)(`Rule Count: ${result.library.count}`);
    (0, screen_1.print)(`Location Count: ${result.library.locationCount}`);
    (0, screen_1.print)();
    for (const location of result.library.locations) {
        (0, screen_1.print)(`${screen_1.OBJECT_ICONS.ruleLocation.get()} ${location.name}`, 2);
        (0, screen_1.print)(`Rule Count: ${location.count}`, 5);
        for (const rule of location.rules) {
            (0, screen_1.print)(`${screen_1.OBJECT_ICONS.rule.get()} ${rule.title}`, 5);
            if (rule.categories.length > 0) {
                (0, screen_1.print)(rule.categories.map(x => `${screen_1.OBJECT_ICONS.ruleCategory.get()} ${x}`).join(' '), 9);
            }
            (0, screen_1.print)(`Name: ${rule.name}`, 9);
            (0, screen_1.print)(`Path: ${rule.path}`, 9);
            (0, screen_1.print)();
        }
    }
    (0, screen_1.print)(`Library Index: ${result.libraryPath}`);
    (0, screen_1.printProcessStatus)(result.success ? 'pass' : 'fail', 'Index Generation');
}
exports.output = output;
//# sourceMappingURL=output.js.map