"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const rule_library_1 = __importDefault(require("./rule-library"));
const lint_1 = __importDefault(require("./lint"));
const guard_1 = __importDefault(require("./guard"));
function default_1(program) {
    const command = program
        .command('install-git-hook')
        .summary("Set up GIT pre-commit hooks to validate Kubernetes manifests before committing.")
        .description(`
Uses pre-commit project to set up GIT pre-commit hooks. 
Learn more: https://pre-commit.com/

Hooks execute in containers, so Docker Desktop should be running.
Available hooks: https://github.com/kubevious/cli/blob/main/.pre-commit-hooks.yaml
`);
    (0, guard_1.default)(command);
    (0, lint_1.default)(command);
    (0, rule_library_1.default)(command);
}
exports.default = default_1;
//# sourceMappingURL=index.js.map