"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.output = void 0;
const screen_1 = require("../../screen");
function output(result) {
    for (const step of result.steps) {
        if (step.success) {
            (0, screen_1.printInfoLine)(step.name, 3);
        }
        else {
            (0, screen_1.printErrorLine)(step.name, 3);
        }
    }
    (0, screen_1.printProcessStatus)(result.success ? 'pass' : 'fail', 'Install Git Hook');
    (0, screen_1.printErrors)(result.errors, 3);
    if (result.success) {
        (0, screen_1.print)('Now you can run: ', 3);
        (0, screen_1.print)(`$> cd ${result.repoPath}`, 5);
        (0, screen_1.print)(`$> git add .pre-commit-config.yaml`, 5);
        (0, screen_1.print)('$> pre-commit autoupdate', 5);
    }
}
exports.output = output;
//# sourceMappingURL=output.js.map