"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OPTION_JSON = exports.OPTION_DETAILED = exports.OPTION_IGNORE_PATTERNS = exports.OPTION_IGNORE_FILE = exports.OPTION_KUBECONFIG = exports.OPTION_K8S_SKIP_TLS_VERIFY = exports.OPTION_LIVE_K8S = exports.OPTION_K8S_VERSION = exports.OPTION_STREAM = exports.OPTION_SKIP_APPLY_CRDS = exports.OPTION_IGNORE_NON_K8S = exports.OPTION_IGNORE_UNKNOWN = exports.ARG_PATH = exports.DESCRIPTION = exports.SUMMARY = void 0;
const docs_1 = require("../../screen/docs");
const samples_1 = require("./samples");
exports.SUMMARY = "Check Kubernetes manifests for API syntax validity.";
exports.DESCRIPTION = `${exports.SUMMARY}

${(0, docs_1.generateUsageSample)(samples_1.SAMPLES)}`;
exports.ARG_PATH = 'Path to files, directories, search patterns, URLs, HELM Charts, Kustomize, etc';
exports.OPTION_IGNORE_UNKNOWN = 'Ignore unknown resources. Use when manifests include CRDs and not using --live-k8s option.';
exports.OPTION_IGNORE_NON_K8S = 'Ignore non-k8s files.';
exports.OPTION_SKIP_APPLY_CRDS = 'Skips CRD application.';
exports.OPTION_STREAM = 'Also read manifests from stream.';
exports.OPTION_K8S_VERSION = 'Target Kubernetes version. Do not use with --live-k8s option.';
exports.OPTION_LIVE_K8S = 'Lint against live Kubernetes cluster. Allows validation of CRDs. Do not use with --k8s-version option.';
exports.OPTION_K8S_SKIP_TLS_VERIFY = 'Skips TLS certificate verification when connecting to live K8s. Has effects when using with --live-k8s option.';
exports.OPTION_KUBECONFIG = 'Optionally set the path to the kubeconfig file. Use with --live-k8s option.';
exports.OPTION_IGNORE_FILE = 'Path to .gitignore file to filter out input patterns.';
exports.OPTION_IGNORE_PATTERNS = 'File patters to ignore.';
exports.OPTION_DETAILED = 'Detailed output.';
exports.OPTION_JSON = 'Output command result in JSON.';
//# sourceMappingURL=docs.js.map