"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.formatResult = void 0;
const logger_1 = require("../../logger");
const counters_1 = require("../../manifests/counters");
const myLogger = logger_1.logger.sublogger('LintFormat');
function formatResult({ manifestPackage, k8sSchemaInfo, }) {
    const packageResult = manifestPackage.exportResult();
    // myLogger.info(">>>>>>>>>>>>>>>>>>>>>>>");
    // myLogger.info("RESULT: ", packageResult);
    // myLogger.info(">>>>>>>>>>>>>>>>>>>>>>>");
    const success = packageResult.severity == 'pass' || packageResult.severity == 'warning';
    myLogger.info("Success: %s", success);
    const result = {
        success: success,
        severity: packageResult.severity,
        packageResult: packageResult,
        targetK8sVersion: k8sSchemaInfo.targetVersion || undefined,
        selectedK8sVersion: k8sSchemaInfo.selectedVersion || undefined,
        foundK8sVersion: k8sSchemaInfo.found,
        foundExactK8sVersion: k8sSchemaInfo.foundExact,
        counters: (0, counters_1.calculateManifestPackageCounters)(packageResult)
    };
    //     outputSource.manifests = 
    //         _.chain(outputSource.manifests)
    //         .orderBy([x => x.namespace, x => x.api, x => x.version, x => x.kind, x => x.name])
    //         .value();
    // result.sources = 
    //     _.chain(result.sources)
    //      .orderBy([x => x.kind, x => x.path])
    //      .value();
    return result;
}
exports.formatResult = formatResult;
//# sourceMappingURL=format.js.map