"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.setupProgram = void 0;
const commander_1 = require("commander");
const version_1 = __importDefault(require("../../version"));
const lint_1 = __importDefault(require("../lint"));
const guard_1 = __importDefault(require("../guard"));
const list_known_k8s_versions_1 = __importDefault(require("../list-known-k8s-versions"));
const index_library_1 = __importDefault(require("../index-library"));
const install_git_hook_1 = __importDefault(require("../install-git-hook"));
const support_1 = __importDefault(require("../support"));
const docs_1 = require("./docs");
function setupProgram() {
    commander_1.program
        .name('kubevious')
        .summary(docs_1.SUMMARY)
        .description(docs_1.DESCRIPTION)
        .version(version_1.default);
    (0, guard_1.default)(commander_1.program);
    (0, lint_1.default)(commander_1.program);
    (0, list_known_k8s_versions_1.default)(commander_1.program);
    (0, index_library_1.default)(commander_1.program);
    (0, install_git_hook_1.default)(commander_1.program);
    (0, support_1.default)(commander_1.program);
    commander_1.program.parse();
}
exports.setupProgram = setupProgram;
//# sourceMappingURL=index.js.map