export type ActionFunc<TData> = (...args: any[]) => TData | Promise<TData>;
export type FormatFunc<TData, TResult> = (data: TData) => TResult;
export type OutputFunc<TResult> = (result: TResult, detailed?: boolean) => void;
export type DesideSuccess<TResult> = (result: TResult) => number;
export declare class CommandBuilder<TData, TResult> {
    private _action?;
    private _format?;
    private _output?;
    private _decideSuccess?;
    constructor();
    perform(action: ActionFunc<TData>): this;
    format(format: FormatFunc<TData, TResult>): this;
    output(output: OutputFunc<TResult>): this;
    decideSuccess(decideSuccess: DesideSuccess<TResult>): this;
    build(): (...args: any[]) => Promise<void>;
}
//# sourceMappingURL=command-action.d.ts.map