import { ILogger } from 'the-logger';
import { OriginalSource } from '../input/original-source';
export interface InputSourceExtractorOptions {
    gitignore?: string;
    ignorePatterns: string[];
}
export declare class InputSourceExtractor {
    private _logger;
    private _options;
    private _ignorePatterns;
    private _originalSources;
    constructor(logger: ILogger, options: InputSourceExtractorOptions);
    init(): Promise<void>;
    get sources(): import("./input-source").InputSource[];
    get originalSources(): OriginalSource[];
    addMany(fileOrPatternOrUrls: string[]): void;
    addSingle(fileOrPatternOrUrl: string): void;
    extractSources(): Promise<void>;
    reconcile(): void;
    debugOutput(): void;
    private loadGitIgnore;
}
//# sourceMappingURL=input-source-extractor.d.ts.map