import { OriginalSource } from './original-source';
import { UserPathSuffixes } from './utils';
export declare class InputSource {
    private _originalSource;
    private _kind;
    private _path;
    private _suffixes;
    private _key;
    private _file;
    private _dir;
    private _isSkipped;
    private _isLoaded;
    private _preprocessor;
    constructor(originalSource: OriginalSource, kind: InputSourceKind, path: string);
    get originalSource(): OriginalSource;
    get key(): string;
    get kind(): InputSourceKind;
    get path(): string;
    get suffixes(): UserPathSuffixes;
    get file(): string;
    get dir(): string;
    get isLoaded(): boolean;
    set isLoaded(value: boolean);
    get isSkipped(): boolean;
    set isSkipped(value: boolean);
    get preprocessor(): string | null;
    get isPreprocessor(): boolean;
    checkPreprocessor(): void;
    static makeFromPath(originalSource: OriginalSource, path: string): InputSource;
}
export declare enum InputSourceKind {
    file = "file",
    web = "web",
    helm = "helm"
}
//# sourceMappingURL=input-source.d.ts.map