import { ManifestSourceType } from "../types/manifest";
import { InputSource } from "./input-source";
import { UserPathSuffixes } from "./utils";
export interface OriginalSourceOptions {
    ignorePatterns?: string[];
}
export declare class OriginalSource {
    private _kind;
    private _originalPath;
    private _path;
    private _suffixes;
    private _logger;
    private _isExtracted;
    private _options;
    private _sources;
    private _allSources;
    private _reconcilerDirsToDelete;
    constructor(origPath: string, options?: OriginalSourceOptions);
    get kind(): ManifestSourceType;
    get originalPath(): string;
    get path(): string;
    get suffixes(): UserPathSuffixes;
    get sources(): InputSource[];
    get hasAnyInput(): boolean;
    extractInputSources(): Promise<void>;
    reconcile(): void;
    private _addFromFileOrPattern;
    private _includePreprocessorSource;
    private _makeSearchPattern;
    includeRawSource(source: InputSource): void;
    debugOutput(): void;
}
//# sourceMappingURL=original-source.d.ts.map