"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseUserInputPath = void 0;
const the_lodash_1 = __importDefault(require("the-lodash"));
const path_1 = require("../utils/path");
function parseUserInputPath(str) {
    var _a, _b, _c;
    let parts = str.split("@");
    let head = '';
    let kind = 'file';
    if (the_lodash_1.default.startsWith(str, '@')) {
        parts = the_lodash_1.default.drop(parts);
        head = (_a = the_lodash_1.default.head(parts)) !== null && _a !== void 0 ? _a : '';
        parts = the_lodash_1.default.drop(parts);
        kind = head;
        if (kind !== 'helm') {
            return {
                isInvalid: true,
                kind: 'file',
                path: str,
                suffixes: []
            };
        }
        head = (_b = the_lodash_1.default.head(parts)) !== null && _b !== void 0 ? _b : "";
        parts = the_lodash_1.default.drop(parts);
    }
    else {
        head = (_c = the_lodash_1.default.head(parts)) !== null && _c !== void 0 ? _c : "";
        parts = the_lodash_1.default.drop(parts);
        const isWeb = (0, path_1.isWebPath)(head);
        if (isWeb) {
            kind = 'web';
        }
    }
    if (!head) {
        return {
            isInvalid: true,
            kind: kind,
            path: '',
            suffixes: []
        };
    }
    const result = {
        kind: kind,
        path: head,
        suffixes: parts.map(x => parseSuffix(x))
    };
    return result;
}
exports.parseUserInputPath = parseUserInputPath;
function parseSuffix(str) {
    const index = str.indexOf("=");
    if (index === -1) {
        return {
            key: '',
            value: str
        };
    }
    else {
        return {
            key: str.substring(0, index),
            value: str.substring(index + 1)
        };
    }
}
//# sourceMappingURL=utils.js.map