"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.logger = exports.rootLogger = void 0;
const the_lodash_1 = __importDefault(require("the-lodash"));
const the_logger_1 = require("the-logger");
const loggerOptions = new the_logger_1.LoggerOptions();
loggerOptions.pretty(true);
let logLevel = the_logger_1.LogLevel.warn;
if (process.env.LOG_LEVEL) {
    logLevel = process.env.LOG_LEVEL;
}
loggerOptions.level(logLevel);
if (process.env.LOG_TO_FILE &&
    (process.env.LOG_TO_FILE == 'true' || process.env.LOG_TO_FILE == 'yes')) {
    loggerOptions.enableFile(true);
    loggerOptions.cleanOnStart(true);
}
const LogLevelOverridePrefix = 'LOG_LEVEL_';
for (const key of the_lodash_1.default.keys(process.env).filter(x => the_lodash_1.default.startsWith(x, LogLevelOverridePrefix))) {
    const sublevelName = key.substring(LogLevelOverridePrefix.length);
    const logLevel = process.env[key];
    loggerOptions.subLevel(sublevelName, logLevel);
}
exports.rootLogger = (0, the_logger_1.setupRootLogger)('CLI', loggerOptions);
exports.logger = exports.rootLogger.logger;
//# sourceMappingURL=logger.js.map