import { BaseObject } from '../types/base-object';
import { K8sObject, K8sObjectId } from "../types/k8s";
import { ManifestInfoResult, ManifestResult } from '../types/manifest-result';
import { SourceInfoResult } from '../types/source-result';
import { ManifestSource } from './manifest-source';
export interface K8sManifestRuleResult {
    processed?: boolean;
    errors?: boolean;
    warnings?: boolean;
}
export declare class K8sManifest extends BaseObject {
    private _idKey;
    private _id;
    private _config;
    private _source;
    private _isLinted;
    private _rules;
    private _errorsWithRule?;
    constructor(config: K8sObject, source: ManifestSource);
    get id(): K8sObjectId;
    get idKey(): string;
    get config(): K8sObject;
    get source(): ManifestSource;
    get isLinted(): boolean;
    set isLinted(value: boolean);
    get errorsWithRule(): boolean | undefined;
    set errorsWithRule(value: boolean | undefined);
    get rules(): K8sManifestRuleResult;
    exportInfoResult(): ManifestInfoResult;
    exportSourcesResult(): SourceInfoResult[];
    exportResult(): ManifestResult;
}
//# sourceMappingURL=k8s-manifest.d.ts.map