"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.K8sManifest = void 0;
const base_object_1 = require("../types/base-object");
const k8s_1 = require("../types/k8s");
class K8sManifest extends base_object_1.BaseObject {
    constructor(config, source) {
        super();
        this._isLinted = false;
        this._rules = {};
        this._config = config;
        this._source = source;
        this._id = (0, k8s_1.makeId)(config);
        this._idKey = (0, k8s_1.makeK8sKeyStr)(config);
    }
    get id() {
        return this._id;
    }
    get idKey() {
        return this._idKey;
    }
    get config() {
        return this._config;
    }
    get source() {
        return this._source;
    }
    get isLinted() {
        return this._isLinted;
    }
    set isLinted(value) {
        this._isLinted = value;
    }
    get errorsWithRule() {
        return this._errorsWithRule;
    }
    set errorsWithRule(value) {
        this._errorsWithRule = value;
    }
    get rules() {
        return this._rules;
    }
    exportInfoResult() {
        const baseResult = this.extractBaseResult();
        const manifestInfoResult = Object.assign(Object.assign({}, this._id), baseResult);
        return manifestInfoResult;
    }
    exportSourcesResult() {
        const sources = [];
        let source = this._source;
        while (source && source.id.kind !== 'root') {
            sources.push(source.extractInfoResult());
            source = source.parentSource;
        }
        return sources;
    }
    exportResult() {
        const manifestResult = Object.assign(Object.assign({}, this.exportInfoResult()), { sources: this.exportSourcesResult() });
        return manifestResult;
    }
}
exports.K8sManifest = K8sManifest;
//# sourceMappingURL=k8s-manifest.js.map