import { ILogger } from 'the-logger';
import { K8sObject } from '../types/k8s';
import { ManifestSourceType } from '../types/manifest';
import { K8sManifest } from './k8s-manifest';
import { ManifestSource } from "./manifest-source";
import { OriginalSource } from '../input/original-source';
import { BaseObject } from '../types/base-object';
import { ManifestPackageResult } from '../types/manifest-result';
export declare class ManifestPackage extends BaseObject {
    private _logger;
    private _rootSource;
    private _manifests;
    private _namespaces;
    constructor(logger: ILogger);
    get sources(): ManifestSource[];
    get manifests(): K8sManifest[];
    get namespaces(): string[];
    getSource(kind: ManifestSourceType, path: string, originalSource: OriginalSource | null, parentSource?: ManifestSource): ManifestSource;
    addManifest(source: ManifestSource, k8sObject: K8sObject): K8sManifest;
    produceNamespaces(): void;
    debugOutput(): void;
    private _debugOutputSource;
    private _debugOutputSourceTree;
    protected yieldChildren(): BaseObject[];
    exportResult(): ManifestPackageResult;
}
//# sourceMappingURL=manifest-package.d.ts.map