import { ManifestSourceId, ManifestSourceType } from "../types/manifest";
import { K8sManifest } from './k8s-manifest';
import { OriginalSource } from '../input/original-source';
import { BaseObject } from '../types/base-object';
import { SourceInfoResult, SourceResult } from '../types/source-result';
export declare class ManifestSource extends BaseObject {
    private _id;
    private _idKey;
    private _manifests;
    private _parentSource;
    private _childSources;
    originalSource: OriginalSource | null;
    constructor(kind: ManifestSourceType, path: string, originalSource: OriginalSource | null);
    get idKey(): string;
    get id(): ManifestSourceId;
    get manifests(): K8sManifest[];
    get parentSource(): ManifestSource | null;
    get childSources(): ManifestSource[];
    getSource(kind: ManifestSourceType, path: string, originalSource: OriginalSource | null, isAbsolutePath?: boolean): ManifestSource;
    addManifest(k8sManifest: K8sManifest): void;
    extractInfoResult(): SourceInfoResult;
    exportResult(): SourceResult;
    protected yieldChildren(): BaseObject[];
}
export declare function makeSourceKey(kind: ManifestSourceType, path: string): string;
//# sourceMappingURL=manifest-source.d.ts.map