"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PathResolver = void 0;
const path_1 = __importDefault(require("path"));
class PathResolver {
    get distDir() {
        return __dirname;
    }
    get rootDir() {
        return path_1.default.resolve(this.distDir, '..');
    }
    get assetsDir() {
        return path_1.default.resolve(this.rootDir, 'assets');
    }
    get k8sApiSchemaDir() {
        if (process.env.K8S_API_SCHEMA_DIR) {
            return process.env.K8S_API_SCHEMA_DIR;
        }
        else {
            return path_1.default.join(this.assetsDir, 'k8s-api-json-schema');
        }
    }
    get cliCrdsDir() {
        if (process.env.KUBEVIOUS_CRDS_DIR) {
            return process.env.KUBEVIOUS_CRDS_DIR;
        }
        else {
            return path_1.default.join(this.assetsDir, 'crds');
        }
    }
}
exports.PathResolver = PathResolver;
//# sourceMappingURL=path-resolver.js.map