"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CachedK8sRegistry = void 0;
const the_lodash_1 = __importDefault(require("the-lodash"));
class CachedK8sRegistry {
    constructor(logger, innerRegistry) {
        this._cache = {};
        this._logger = logger.sublogger('CachedK8sRegistry');
        this._innerRegistry = innerRegistry;
    }
    query(query) {
        // this._logger.info("[query] ", query);
        const key = the_lodash_1.default.stableStringify(query);
        const cachedResult = this._cache[key];
        if (the_lodash_1.default.isNotNullOrUndefined(cachedResult)) {
            return cachedResult;
        }
        const result = this._innerRegistry.query(query);
        this._cache[key] = result;
        return result;
    }
}
exports.CachedK8sRegistry = CachedK8sRegistry;
//# sourceMappingURL=cached-k8s-registry.js.map