"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LocalSourceRegistry = void 0;
const the_lodash_1 = __importDefault(require("the-lodash"));
class LocalSourceRegistry {
    constructor(logger, manifestPackage) {
        this._multiFlatDict = {};
        this._flatDict = {};
        this._logger = logger.sublogger('LocalSourceRegistry');
        this._manifestPackage = manifestPackage;
    }
    get manifests() {
        return the_lodash_1.default.values(this._flatDict);
    }
    add(manifest) {
        const key = the_lodash_1.default.stableStringify(manifest.id);
        this._flatDict[key] = manifest;
        if (!this._multiFlatDict[key]) {
            this._multiFlatDict[key] = [];
        }
        this._multiFlatDict[key].push(manifest);
    }
    validateDuplicates() {
        for (const key of the_lodash_1.default.keys(this._multiFlatDict)) {
            const manifests = this._multiFlatDict[key];
            if (manifests.length > 1) {
                for (const manifest of manifests) {
                    const message = 'Manifest is defined in multiple sources.';
                    manifest.reportError(message);
                }
            }
        }
    }
}
exports.LocalSourceRegistry = LocalSourceRegistry;
//# sourceMappingURL=local-source-registry.js.map