import { ILogger } from 'the-logger';
import { RuleObject } from '../registry/types';
import { TargetProcessor } from './target/processor';
import { CacheProcessor } from './cache/processor';
import { ValidationProcessor } from './validator/processor';
import { ExecutionContext } from '../execution/execution-context';
export declare class RuleCompiler {
    private _logger;
    private _ruleObject;
    private _targetProcessor;
    private _validationProcessor;
    private _globalCacheProcessor?;
    private _localCacheProcessor?;
    private _isCompiled;
    private _hasRuntimeErrors;
    private _ruleErrors;
    constructor(logger: ILogger, ruleObject: RuleObject, targetExecutionContext: ExecutionContext, validatorExecutionContext: ExecutionContext);
    get rule(): RuleObject;
    get isCompiled(): boolean;
    get hasRuntimeErrors(): boolean;
    get ruleErrors(): RuleError[];
    get targetProcessor(): TargetProcessor;
    get validationProcessor(): ValidationProcessor;
    get globalCacheProcessor(): CacheProcessor | undefined;
    get localCacheProcessor(): CacheProcessor | undefined;
    compile(): Promise<void | undefined>;
    reportScriptErrors(source: string, messages: string[]): void;
}
export interface RuleError {
    source: string;
    msg: string;
}
//# sourceMappingURL=rule-compiler.d.ts.map