import { ScriptItem } from '../../script-item';
import { ExecutionContext } from '../../execution/execution-context';
export interface ValidationProcessorResult {
    success: boolean;
    messages: string[];
    validation: {
        hasErrors: boolean;
        hasWarnings: boolean;
        errorMsgs: {
            [name: string]: boolean;
        };
        warnMsgs: {
            [name: string]: boolean;
        };
        marks?: {
            [name: string]: boolean;
        };
    };
}
export declare class ValidationProcessor {
    private _runnable;
    private _src;
    private _logger;
    private _executionContext;
    constructor(src: string, executionContext: ExecutionContext);
    prepare(): Promise<{
        success: boolean;
        messages: never[];
    }>;
    private _loadModule;
    private _validate;
    execute(item: ScriptItem, globalCache: Record<string, any>, cache: Record<string, any>, values: Record<string, any>): Promise<ValidationProcessorResult>;
    private _setupQueryBuilders;
    private _addError;
}
//# sourceMappingURL=processor.d.ts.map