"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ExecutionContext = void 0;
const query_executor_1 = require("../query/query-executor");
class ExecutionContext {
    constructor(logger, registryQueryExecutor, manifestPackage) {
        this._logger = logger.sublogger("ExecutionContext");
        this._registryQueryExecutor = registryQueryExecutor;
        this._manifestPackage = manifestPackage;
        this._queryExecutor = new query_executor_1.QueryExecutor(this);
    }
    get logger() {
        return this._logger;
    }
    get registryQueryExecutor() {
        return this._registryQueryExecutor;
    }
    get manifestPackage() {
        return this._manifestPackage;
    }
    get queryExecutor() {
        return this._queryExecutor;
    }
}
exports.ExecutionContext = ExecutionContext;
//# sourceMappingURL=execution-context.js.map