import { ILogger } from 'the-logger';
import { RuleApplicationScope, RuleObject } from '../registry/types';
import { RuleOverrideValues } from '../spec/rule-spec';
import { K8sManifest } from '../../manifests/k8s-manifest';
import { RuleRuntime } from './rule-runtime';
export declare class RuleExecutionRuntime {
    private _logger;
    private _ruleObject;
    private _manifest;
    private _application;
    private _values;
    private _ruleRuntime;
    constructor(logger: ILogger, manifest: K8sManifest, ruleObject: RuleObject, ruleRuntime: RuleRuntime, application: RuleApplicationScope, values: RuleOverrideValues);
    get compiler(): import("../compiler/rule-compiler").RuleCompiler;
    get rule(): import("../registry/types").CommonRule;
    get application(): RuleApplicationScope;
    get isCompiled(): boolean;
    get hasRuntimeErrors(): boolean;
    get ruleEngineReporter(): import("../reporting/rule-engine-reporter").RuleEngineReporter;
    execute(): Promise<void>;
    private _processTarget;
    private _processItem;
    private _processValidation;
    private _processValidationResult;
    private _reportError;
    private _reportWarning;
}
//# sourceMappingURL=rule-execution-runtime.d.ts.map