"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NameLookupDict = void 0;
const the_lodash_1 = __importDefault(require("the-lodash"));
class NameLookupDict {
    constructor() {
        this._dict = {};
    }
    get length() {
        return the_lodash_1.default.keys(this._dict).length;
    }
    add(item) {
        var _a;
        this._dict[(_a = item.name) !== null && _a !== void 0 ? _a : ""] = item;
    }
    addMany(items) {
        if (items) {
            for (const x of items) {
                this.add(x);
            }
        }
    }
    resolve(name) {
        var _a;
        name = name !== null && name !== void 0 ? name : "";
        return (_a = this._dict[name]) !== null && _a !== void 0 ? _a : null;
    }
    contains(name) {
        return this.resolve(name) ? true : false;
    }
}
exports.NameLookupDict = NameLookupDict;
//# sourceMappingURL=dict.js.map