"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RULE_HELPERS = void 0;
const image_1 = require("./image");
const label_lookup_1 = require("./label-lookup");
const name_lookup_1 = require("./name-lookup");
const labels_1 = require("./labels");
const data_structs_1 = require("./data-structs");
const gateway_api_1 = require("./gateway-api");
const traefik_1 = require("./vendor/traefik");
exports.RULE_HELPERS = {
    parseImage: image_1.parseImage,
    newLabelLookupDict: label_lookup_1.newLabelLookupDict,
    newNameLookupDict: name_lookup_1.newNameLookupDict,
    labelsToString: labels_1.labelsToString,
    findDuplicates: data_structs_1.findDuplicates,
    gateway: {
        isInternalService: gateway_api_1.isInternalService
    },
    traefik: {
        parseRef: traefik_1.parseRef
    }
};
//# sourceMappingURL=rule-helpers.js.map