"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseRef = void 0;
function parseRef(ref) {
    const parts = ref.split('@');
    if (parts.length == 1) {
        return {
            name: ref,
            type: 'kubernetescrd',
            isK8s: true,
        };
    }
    else if (parts.length == 2) {
        return {
            name: parts[0],
            type: parts[1],
            isK8s: parts[1] === 'kubernetescrd'
        };
    }
    else {
        return {
            name: ref,
            type: '',
            isK8s: false
        };
    }
}
exports.parseRef = parseRef;
//# sourceMappingURL=traefik.js.map