import { K8sTargetQuery } from './k8s/k8s-target-query';
import { UnionTargetQuery } from './union/union-target-query';
import { TransformTargetQuery } from './transform/transform-target-query';
import { BaseTargetQuery } from './base';
import { ShortcutTargetQuery } from './shortcut/shortcut-target-query';
import { FilterTargetQuery } from './filter/filter-target-query';
import { TransformManyTargetQuery } from './transform-many/transform-many-target-query';
import { ManualQueryFunc, ManualTargetQuery } from './manual/manual-target-query';
import { FirstTargetQuery } from './first/first-target-query';
export declare class TargetQueryBuilderDef {
    get Shortcut(): (name: string, ...args: any[]) => ShortcutTargetQuery;
    get ApiVersion(): (apiVersion: string) => K8sTargetQuery;
    get Api(): (apiName: string) => K8sTargetQuery;
    get Union(): (...inner: BaseTargetQuery[]) => UnionTargetQuery;
    get Transform(): (inner: BaseTargetQuery) => TransformTargetQuery;
    get TransformMany(): (inner: BaseTargetQuery) => TransformManyTargetQuery;
    get Filter(): (inner: BaseTargetQuery) => FilterTargetQuery;
    get First(): (...inner: BaseTargetQuery[]) => FirstTargetQuery;
    get Manual(): (func: ManualQueryFunc) => ManualTargetQuery;
}
export declare const TARGET_QUERY_BUILDER_OBJ: TargetQueryBuilderDef;
export type TargetQueryFunc = (...args: any[]) => BaseTargetQuery;
export declare const TARGET_QUERY_BUILDER_DICT: Record<string, TargetQueryFunc>;
//# sourceMappingURL=scope-builder.d.ts.map