"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FilterQueryExecutor = void 0;
class FilterQueryExecutor {
    constructor(executionContext) {
        this._executionContext = executionContext;
        this._logger = executionContext.logger.sublogger("FilterQueryExecutor");
    }
    execute(query, limiter) {
        const result = {
            success: true,
            items: []
        };
        const innerResult = this._executionContext.queryExecutor.execute(query._inner, limiter);
        if (innerResult.items) {
            for (const item of innerResult.items) {
                if (query._func) {
                    if (query._func(item)) {
                        result.items.push(item);
                    }
                }
            }
        }
        return result;
    }
}
exports.FilterQueryExecutor = FilterQueryExecutor;
//# sourceMappingURL=filter-query-executor.js.map