"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FirstQueryExecutor = void 0;
const the_lodash_1 = __importDefault(require("the-lodash"));
class FirstQueryExecutor {
    constructor(executionContext) {
        this._executionContext = executionContext;
        this._logger = executionContext.logger.sublogger("FirstQueryExecutor");
    }
    execute(query, limiter) {
        for (const innerQuery of query._inner) {
            const innerResult = this._executionContext.queryExecutor.execute(innerQuery, limiter);
            if (innerResult.items) {
                const item = the_lodash_1.default.head(innerResult.items);
                if (item) {
                    return {
                        success: true,
                        items: [item]
                    };
                }
            }
        }
        return {
            success: false,
            items: []
        };
    }
}
exports.FirstQueryExecutor = FirstQueryExecutor;
//# sourceMappingURL=first-query-executor.js.map