"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ManualQueryExecutor = void 0;
const query_executor_scope_1 = require("../query-executor-scope");
class ManualQueryExecutor {
    constructor(executionContext) {
        this._executionContext = executionContext;
        this._logger = executionContext.logger.sublogger("ManualQueryExecutor");
    }
    execute(query, limiter) {
        var _a;
        const result = {
            success: true,
            items: []
        };
        const func = query._func;
        if (func) {
            const queryScope = new query_executor_scope_1.QueryExecutorScope(this._executionContext, limiter);
            const funcArgs = {
                many: (innerQuery) => queryScope.many(innerQuery),
                single: (innerQuery) => queryScope.single(innerQuery),
                count: (innerQuery) => queryScope.count(innerQuery)
            };
            const scriptItems = (_a = func(funcArgs)) !== null && _a !== void 0 ? _a : [];
            for (const item of scriptItems) {
                result.items.push(item);
            }
        }
        return result;
    }
}
exports.ManualQueryExecutor = ManualQueryExecutor;
//# sourceMappingURL=manual-query-executor.js.map