"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.QueryExecutorScope = void 0;
const the_lodash_1 = __importDefault(require("the-lodash"));
class QueryExecutorScope {
    constructor(executionContext, limiter) {
        this._logger = executionContext.logger.sublogger("QueryExecutorScope");
        this._executionContext = executionContext;
        this._limiter = limiter;
    }
    many(query) {
        var _a;
        const result = this._executionContext.queryExecutor.execute(query, this._limiter);
        if (result.messages) {
            for (const x of result.messages) {
                this._logger.error("Error in query: %s", x);
            }
        }
        return (_a = result.items) !== null && _a !== void 0 ? _a : [];
    }
    single(query) {
        var _a;
        return (_a = the_lodash_1.default.head(this.many(query))) !== null && _a !== void 0 ? _a : null;
    }
    count(query) {
        return this.many(query).length;
    }
}
exports.QueryExecutorScope = QueryExecutorScope;
//# sourceMappingURL=query-executor-scope.js.map