"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.setup = void 0;
const scope_builder_1 = require("../../query-spec/scope-builder");
function setup(executor) {
    const { Shortcut, ApiVersion, Api, Union, Transform, TransformMany, Filter, First } = scope_builder_1.TARGET_QUERY_BUILDER_OBJ;
    executor.setup('DeploymentPodSpec', () => Transform(ApiVersion('apps/v1')
        .Kind("Deployment")).To(item => {
        var _a, _b, _c, _d, _e;
        return ({
            synthetic: true,
            apiVersion: 'v1',
            kind: 'PodSpec',
            metadata: Object.assign(Object.assign({}, (_c = (_b = (_a = item.config.spec) === null || _a === void 0 ? void 0 : _a.template) === null || _b === void 0 ? void 0 : _b.metadata) !== null && _c !== void 0 ? _c : {}), { name: `Deployment-${item.name}`, namespace: item.namespace }),
            spec: (_e = (_d = item.config.spec) === null || _d === void 0 ? void 0 : _d.template) === null || _e === void 0 ? void 0 : _e.spec,
            controllerConfig: item.config
        });
    }));
    executor.setup('StatefulSetPodSpec', () => Transform(ApiVersion('apps/v1')
        .Kind("StatefulSet")).To(item => {
        var _a, _b, _c, _d, _e;
        return ({
            synthetic: true,
            apiVersion: 'v1',
            kind: 'PodSpec',
            metadata: Object.assign(Object.assign({}, (_c = (_b = (_a = item.config.spec) === null || _a === void 0 ? void 0 : _a.template) === null || _b === void 0 ? void 0 : _b.metadata) !== null && _c !== void 0 ? _c : {}), { name: `StatefulSet-${item.name}`, namespace: item.namespace }),
            spec: (_e = (_d = item.config.spec) === null || _d === void 0 ? void 0 : _d.template) === null || _e === void 0 ? void 0 : _e.spec,
            controllerConfig: item.config
        });
    }));
    executor.setup('DaemonSetPodSpec', () => Transform(ApiVersion('apps/v1')
        .Kind("DaemonSet")).To(item => {
        var _a, _b, _c, _d, _e;
        return ({
            synthetic: true,
            apiVersion: 'v1',
            kind: 'PodSpec',
            metadata: Object.assign(Object.assign({}, (_c = (_b = (_a = item.config.spec) === null || _a === void 0 ? void 0 : _a.template) === null || _b === void 0 ? void 0 : _b.metadata) !== null && _c !== void 0 ? _c : {}), { name: `DaemonSet-${item.name}`, namespace: item.namespace }),
            spec: (_e = (_d = item.config.spec) === null || _d === void 0 ? void 0 : _d.template) === null || _e === void 0 ? void 0 : _e.spec,
            controllerConfig: item.config
        });
    }));
    executor.setup('JobPodSpec', () => Transform(Filter(Api('batch')
        .Kind("Job")).Criteria(item => {
        var _a;
        if ((_a = item.config.metadata) === null || _a === void 0 ? void 0 : _a.ownerReferences) {
            return false;
        }
        return true;
    })).To(item => {
        var _a, _b, _c, _d, _e;
        return ({
            synthetic: true,
            apiVersion: 'v1',
            kind: 'PodSpec',
            metadata: Object.assign(Object.assign({}, (_c = (_b = (_a = item.config.spec) === null || _a === void 0 ? void 0 : _a.template) === null || _b === void 0 ? void 0 : _b.metadata) !== null && _c !== void 0 ? _c : {}), { name: `Job-${item.name}`, namespace: item.namespace }),
            spec: (_e = (_d = item.config.spec) === null || _d === void 0 ? void 0 : _d.template) === null || _e === void 0 ? void 0 : _e.spec,
            controllerConfig: item.config
        });
    }));
    executor.setup('CronJobPodSpec', () => Transform(Api('batch')
        .Kind("CronJob")).To(item => {
        var _a, _b, _c, _d, _e, _f, _g;
        return ({
            synthetic: true,
            apiVersion: 'v1',
            kind: 'PodSpec',
            metadata: Object.assign(Object.assign({}, (_c = (_b = (_a = item.config.spec) === null || _a === void 0 ? void 0 : _a.template) === null || _b === void 0 ? void 0 : _b.metadata) !== null && _c !== void 0 ? _c : {}), { name: `CronJob-${item.name}`, namespace: item.namespace }),
            spec: (_g = (_f = (_e = (_d = item.config.spec) === null || _d === void 0 ? void 0 : _d.jobTemplate) === null || _e === void 0 ? void 0 : _e.spec) === null || _f === void 0 ? void 0 : _f.template) === null || _g === void 0 ? void 0 : _g.spec,
            controllerConfig: item.config
        });
    }));
    executor.setup('ArgoRolloutPodSpec', () => Transform(Api('argoproj.io')
        .Kind("Rollout")).To(item => {
        var _a, _b, _c, _d, _e;
        return ({
            synthetic: true,
            apiVersion: 'v1',
            kind: 'PodSpec',
            metadata: Object.assign(Object.assign({}, (_c = (_b = (_a = item.config.spec) === null || _a === void 0 ? void 0 : _a.template) === null || _b === void 0 ? void 0 : _b.metadata) !== null && _c !== void 0 ? _c : {}), { name: `ArgoRollout-${item.name}`, namespace: item.namespace }),
            spec: (_e = (_d = item.config.spec) === null || _d === void 0 ? void 0 : _d.template) === null || _e === void 0 ? void 0 : _e.spec,
            controllerConfig: item.config
        });
    }));
    executor.setup('PodSpec', () => Union(Shortcut('DeploymentPodSpec'), Shortcut('StatefulSetPodSpec'), Shortcut('DaemonSetPodSpec'), Shortcut('JobPodSpec'), Shortcut('CronJobPodSpec'), Shortcut('ArgoRolloutPodSpec')));
    executor.setup('ContainerSpec', () => TransformMany(Shortcut('PodSpec')).To(item => {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
        const results = [];
        for (const cont of (_b = (_a = item === null || item === void 0 ? void 0 : item.config.spec) === null || _a === void 0 ? void 0 : _a.containers) !== null && _b !== void 0 ? _b : []) {
            results.push({
                synthetic: true,
                apiVersion: 'v1',
                kind: 'ContainerSpec',
                metadata: Object.assign(Object.assign({}, (_e = (_d = (_c = item.config.spec) === null || _c === void 0 ? void 0 : _c.template) === null || _d === void 0 ? void 0 : _d.metadata) !== null && _e !== void 0 ? _e : {}), { name: `${item.name}-Cont-${cont.name}`, namespace: item.namespace }),
                spec: cont,
                isInitContainer: false,
                podSpec: item === null || item === void 0 ? void 0 : item.config.spec,
                controllerConfig: item.config.controllerConfig
            });
        }
        for (const cont of (_g = (_f = item === null || item === void 0 ? void 0 : item.config.spec) === null || _f === void 0 ? void 0 : _f.initContainers) !== null && _g !== void 0 ? _g : []) {
            results.push({
                synthetic: true,
                apiVersion: 'v1',
                kind: 'ContainerSpec',
                metadata: Object.assign(Object.assign({}, (_k = (_j = (_h = item.config.spec) === null || _h === void 0 ? void 0 : _h.template) === null || _j === void 0 ? void 0 : _j.metadata) !== null && _k !== void 0 ? _k : {}), { name: `${item.name}-InitCont-${cont.name}`, namespace: item.namespace }),
                spec: cont,
                isInitContainer: true,
                podSpec: item === null || item === void 0 ? void 0 : item.config.spec,
                controllerConfig: item.config.controllerConfig
            });
        }
        return results;
    }));
    executor.setup('Secret', (name) => First(ApiVersion('v1')
        .Kind("Secret")
        .name(name), Transform(Api('bitnami.com')
        .Kind("SealedSecret")
        .name(name)).To(item => {
        var _a, _b;
        return ({
            synthetic: true,
            apiVersion: 'v1',
            kind: 'Secret',
            metadata: item.config.metadata,
            data: (_b = (_a = item.config.spec) === null || _a === void 0 ? void 0 : _a.encryptedData) !== null && _b !== void 0 ? _b : {}
        });
    })));
}
exports.setup = setup;
//# sourceMappingURL=library.js.map