import { ExecutionContext } from '../../execution/execution-context';
import { QueryResult } from '../base';
import { IQueryExecutor } from '../base';
import { BaseTargetQuery, QueryScopeLimiter } from '../../query-spec/base';
import { ShortcutTargetQuery } from '../../query-spec/shortcut/shortcut-target-query';
export type ShortcutFunc = (...args: any[]) => BaseTargetQuery;
export declare class ShortcutQueryExecutor implements IQueryExecutor<ShortcutTargetQuery> {
    private _logger;
    private _executionContext;
    private _shortcuts;
    constructor(executionContext: ExecutionContext);
    execute(query: ShortcutTargetQuery, limiter: QueryScopeLimiter): QueryResult;
    setup(name: string, func: ShortcutFunc): void;
}
//# sourceMappingURL=shortcut-query-executor.d.ts.map