"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ShortcutQueryExecutor = void 0;
const library_1 = require("./library");
class ShortcutQueryExecutor {
    constructor(executionContext) {
        this._shortcuts = {};
        this._executionContext = executionContext;
        this._logger = executionContext.logger.sublogger("ShortcutQueryExecutor");
        (0, library_1.setup)(this);
    }
    execute(query, limiter) {
        const shortcutFunc = this._shortcuts[query._name];
        if (!shortcutFunc) {
            return {
                success: false,
                messages: [`Unknown shortcut: ${query._name}`]
            };
        }
        const shortcut = shortcutFunc(...query._args);
        return this._executionContext.queryExecutor.execute(shortcut, limiter);
    }
    setup(name, func) {
        this._shortcuts[name] = func;
    }
}
exports.ShortcutQueryExecutor = ShortcutQueryExecutor;
//# sourceMappingURL=shortcut-query-executor.js.map