"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UnionQueryExecutor = void 0;
const the_lodash_1 = __importDefault(require("the-lodash"));
class UnionQueryExecutor {
    constructor(executionContext) {
        this._executionContext = executionContext;
        this._logger = executionContext.logger.sublogger("UnionQueryExecutor");
    }
    execute(query, limiter) {
        const _dict = {};
        for (const innerQuery of query._inner) {
            const innerResult = this._executionContext.queryExecutor.execute(innerQuery, limiter);
            if (innerResult.items) {
                for (const item of innerResult.items) {
                    _dict[item.manifest.idKey] = item;
                }
            }
        }
        const result = {
            success: true,
            items: the_lodash_1.default.values(_dict)
        };
        return result;
    }
}
exports.UnionQueryExecutor = UnionQueryExecutor;
//# sourceMappingURL=union-query-executor.js.map