import { ResultObjectSeverity } from '../types/result';
export declare function indentify(str: string, count?: number): string;
export declare function print(str?: string, indent?: number): void;
export declare function printInfoLine(str: string, indent?: number): void;
export declare function printPassLine(str: string, indent?: number): void;
export declare function printInactivePassLine(str: string, indent?: number): void;
export declare function printFailLine(str: string, indent?: number): void;
export declare function printErrorLine(str: string, indent?: number): void;
export declare function printErrors(lines?: string[], indent?: number): void;
export declare function printWarningLine(str?: string, indent?: number): void;
export declare function printWarnings(lines?: string[], indent?: number): void;
export declare function printSectionTitle(title: string, indent?: number): void;
export declare function printSubTitle(title: string, indent?: number): void;
export declare function printProcessStatus(severity: ResultObjectSeverity, taskName: string): void;
export declare class IconDefinition {
    private _active;
    private _inactive;
    constructor(active: string, inactive?: string);
    get(isActiveOrCount?: boolean | number): string;
}
export declare const STATUS_ICONS: {
    passed: IconDefinition;
    failed: IconDefinition;
    error: IconDefinition;
    warning: IconDefinition;
    question: IconDefinition;
    info: IconDefinition;
};
export declare const OBJECT_ICONS: {
    source: IconDefinition;
    manifest: IconDefinition;
    rule: IconDefinition;
    ruleLocation: IconDefinition;
    ruleCategory: IconDefinition;
};
export declare const SOURCE_ICONS: {
    file: IconDefinition;
    web: IconDefinition;
    stream: IconDefinition;
    k8s: IconDefinition;
    helm: IconDefinition;
    kustomize: IconDefinition;
};
export declare const OTHER_ICONS: {
    email: IconDefinition;
    bug: IconDefinition;
    slack: IconDefinition;
    party: IconDefinition;
};
export declare function printSummaryCounter(icon: IconDefinition, title: string, count: number): void;
//# sourceMappingURL=index.d.ts.map