"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BaseObject = void 0;
const the_lodash_1 = __importDefault(require("the-lodash"));
const result_1 = require("./result");
class BaseObject {
    constructor() {
        this._selfSuccess = true;
        this._selfErrors = [];
        this._selfWarnings = [];
    }
    get success() {
        return this._selfSuccess;
    }
    get selfErrors() {
        return this._selfErrors;
    }
    get errors() {
        return this.selfErrors; //TODO:
    }
    get selfWarnings() {
        return this._selfWarnings;
    }
    get warnings() {
        return this.selfWarnings; //TODO:
    }
    reportError(msg) {
        this._selfErrors.push(msg);
        this._selfSuccess = false;
    }
    reportErrors(msgs) {
        for (const msg of msgs !== null && msgs !== void 0 ? msgs : []) {
            this.reportError(msg);
        }
    }
    reportWarning(msg) {
        this._selfWarnings.push(msg);
    }
    reportWarnings(msgs) {
        for (const msg of msgs !== null && msgs !== void 0 ? msgs : []) {
            this.reportWarning(msg);
        }
    }
    extractBaseResult() {
        const result = {
            severity: 'pass',
        };
        if (this.errors.length > 0) {
            if (!result.messages) {
                result.messages = [];
            }
            result.messages = the_lodash_1.default.concat(result.messages, this.errors.map(x => ({ severity: 'error', msg: x })));
        }
        if (this.warnings.length > 0) {
            if (!result.messages) {
                result.messages = [];
            }
            result.messages = the_lodash_1.default.concat(result.messages, this.warnings.map(x => ({ severity: 'warning', msg: x })));
        }
        (0, result_1.setupBaseObjectSeverity)(result);
        return result;
    }
    yieldChildren() {
        return [];
    }
}
exports.BaseObject = BaseObject;
//# sourceMappingURL=base-object.js.map