"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.makeK8sKeyStr = exports.makeK8sKey = exports.makeId = void 0;
const the_lodash_1 = __importDefault(require("the-lodash"));
const k8s_1 = require("../utils/k8s");
function makeId(k8sObject) {
    var _a, _b;
    const apiVersionParts = (0, k8s_1.parseApiVersion)(k8sObject.apiVersion);
    return {
        apiVersion: k8sObject.apiVersion,
        api: apiVersionParts.group,
        version: apiVersionParts.version,
        kind: k8sObject.kind,
        namespace: (_a = k8sObject.metadata) === null || _a === void 0 ? void 0 : _a.namespace,
        name: (_b = k8sObject.metadata) === null || _b === void 0 ? void 0 : _b.name,
    };
}
exports.makeId = makeId;
function makeK8sKey(k8sObject) {
    var _a, _b;
    return {
        apiVersion: k8sObject.apiVersion,
        kind: k8sObject.kind,
        namespace: (_a = k8sObject.metadata) === null || _a === void 0 ? void 0 : _a.namespace,
        name: (_b = k8sObject.metadata) === null || _b === void 0 ? void 0 : _b.name,
    };
}
exports.makeK8sKey = makeK8sKey;
function makeK8sKeyStr(k8sObject) {
    return the_lodash_1.default.stableStringify(makeK8sKey(k8sObject));
}
exports.makeK8sKeyStr = makeK8sKeyStr;
//# sourceMappingURL=k8s.js.map