export type ResultObjectSeverity = 'pass' | 'fail' | 'warning';
export type ResultMessageSeverity = 'error' | 'warning';
export interface ResultMessage {
    severity: ResultMessageSeverity;
    msg: string;
}
export interface ResultObject {
    severity: ResultObjectSeverity;
    messages?: ResultMessage[];
}
export interface ManifestPackageCounters {
    sources: {
        total: number;
        withErrors: number;
        withWarnings: number;
    };
    manifests: {
        total: number;
        passed: number;
        withErrors: number;
        withWarnings: number;
    };
}
export interface RuleEngineCounters {
    rules: {
        total: number;
        failed: number;
        passed: number;
        withErrors: number;
        withWarnings: number;
    };
    manifests: {
        total: number;
        processed: number;
        passed: number;
        withErrors: number;
        withWarnings: number;
    };
}
export declare function makeObjectSeverity(severity: ResultObjectSeverity, others: ResultObjectSeverity[]): ResultObjectSeverity;
export declare function makeObjectSeverityFromChildren(severity: ResultObjectSeverity, children: ResultObject[]): ResultObjectSeverity;
export declare function setupBaseObjectSeverity(obj: ResultObject): void;
//# sourceMappingURL=result.d.ts.map