"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.setupBaseObjectSeverity = exports.makeObjectSeverityFromChildren = exports.makeObjectSeverity = void 0;
const the_lodash_1 = __importDefault(require("the-lodash"));
function makeObjectSeverity(severity, others) {
    const items = the_lodash_1.default.flatten([[severity], others]);
    const dict = the_lodash_1.default.makeBoolDict(items);
    if (dict['fail']) {
        return 'fail';
    }
    if (dict['warning']) {
        return 'warning';
    }
    return 'pass';
}
exports.makeObjectSeverity = makeObjectSeverity;
function makeObjectSeverityFromChildren(severity, children) {
    return makeObjectSeverity(severity, children.map(x => x.severity));
}
exports.makeObjectSeverityFromChildren = makeObjectSeverityFromChildren;
function setupBaseObjectSeverity(obj) {
    var _a;
    obj.severity = makeObjectSeverity('pass', ((_a = obj.messages) !== null && _a !== void 0 ? _a : []).map(x => {
        if (x.severity === 'error') {
            return 'fail';
        }
        if (x.severity === 'warning') {
            return 'warning';
        }
        return 'pass';
    }));
}
exports.setupBaseObjectSeverity = setupBaseObjectSeverity;
//# sourceMappingURL=result.js.map