"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.sanitizeYaml = void 0;
const the_lodash_1 = __importDefault(require("the-lodash"));
function sanitizeYaml(obj) {
    if (the_lodash_1.default.isArray(obj)) {
        return obj.map(x => sanitizeYaml(x));
    }
    if (the_lodash_1.default.isPlainObject(obj)) {
        for (const key of the_lodash_1.default.keys(obj)) {
            obj[key] = sanitizeYaml(obj[key]);
        }
    }
    if (the_lodash_1.default.isNull(obj)) {
        return undefined;
    }
    return obj;
}
exports.sanitizeYaml = sanitizeYaml;
//# sourceMappingURL=k8s-manifest-sanitizer.js.map