"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getLatestReleaseTag = void 0;
const axios_1 = __importDefault(require("axios"));
function getLatestReleaseTag() {
    var _a;
    return __awaiter(this, void 0, void 0, function* () {
        const RELEASE_URL = 'https://api.github.com/repos/kubevious/cli/releases/latest';
        const result = yield axios_1.default.get(RELEASE_URL);
        const tag = (_a = result === null || result === void 0 ? void 0 : result.data) === null || _a === void 0 ? void 0 : _a.tag_name;
        if (!tag) {
            throw new Error("Could not get the release tag.");
        }
        return tag;
    });
}
exports.getLatestReleaseTag = getLatestReleaseTag;
//# sourceMappingURL=release.js.map