import { ILogger } from 'the-logger';
import { K8sApiJsonSchema } from 'k8s-super-client/dist/open-api/converter/types';
import { K8sObject } from '../types/k8s';
export interface K8sManifestValidatorParams {
    ignoreUnknown?: boolean;
}
export declare class K8sManifestValidator {
    private _logger;
    private _k8sJsonSchema;
    private _params;
    constructor(logger: ILogger, k8sJsonSchema: K8sApiJsonSchema, params?: K8sManifestValidatorParams);
    validate(k8sManifest: K8sObject): K8sManifestValidationResult;
    private _preProcessNode;
    private _preProcessClearEmptyRequiredStrings;
    private _preProcessNodeRef;
    private _mapError;
}
export interface K8sManifestValidationResult {
    success: boolean;
    errors?: string[];
    warnings?: string[];
}
//# sourceMappingURL=k8s-manifest-validator.d.ts.map