import { ILogger } from 'the-logger';
import { K8sApiJsonSchema } from 'k8s-super-client/dist/open-api/converter/types';
import { ManifestPackage } from '../manifests/manifest-package';
export interface K8sPackageValidatorParams {
    skipApplyCrds?: boolean;
    ignoreUnknown?: boolean;
}
export declare class K8sPackageValidator {
    private _logger;
    private _origK8sJsonSchema;
    private _k8sJsonSchema;
    private _manifestPackage;
    private _params;
    private _spinner?;
    constructor(logger: ILogger, k8sJsonSchema: K8sApiJsonSchema, manifestPackage: ManifestPackage, params?: K8sPackageValidatorParams);
    get k8sJsonSchema(): K8sApiJsonSchema;
    validate(): Promise<void>;
    private _applyCRDs;
    private _applyCRD;
    private _fixCRD;
    private _applyCRDToSchema;
    private _isValidCRD;
    private _applyCRDVersion;
    private _convertCrdSchemaToJsonSchema;
    private _validateManifest;
    private _makeSchemaClone;
}
//# sourceMappingURL=k8s-package-validator.d.ts.map