import { NodeKind } from './entities/node-kind';
import { Dn } from './dn-utils';
export type ResolveFunc<T> = (dnParts: Dn) => T;
export type ValueOrResolveFunc<T> = T | ResolveFunc<T>;
export declare class NodeDict<T> {
    private _kindResolver;
    private _pathResolver;
    protected setKind(key: NodeKind, value: ValueOrResolveFunc<T>): void;
    protected setPath(path: NodeKind[], value: ValueOrResolveFunc<T>): void;
    get(dnOrParts: string | Dn): void | NonNullable<T>;
    protected _getDefaultValue(dn?: Dn): void;
}
//# sourceMappingURL=node-dict.d.ts.map