"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PROPS_TOOLTIPS = exports.PropsTooltips = void 0;
var props_id_1 = require("./entities/props-id");
var node_kind_1 = require("./entities/node-kind");
var PropsTooltips = /** @class */ (function () {
    function PropsTooltips() {
        var _a;
        this._values = {};
        this.set(props_id_1.PropsId.properties, 'Top level properties associated with this object.');
        this.set(props_id_1.PropsId.config, 'Kubernetes YAML Configuration');
        this.set(props_id_1.PropsId.labels, 'Kubernetes Labels');
        this.set(props_id_1.PropsId.annotations, 'Kubernetes Annotations');
        this.set(props_id_1.PropsId.targetLinks, 'Links to related objects');
        this.set(props_id_1.PropsId.sharedWith, 'Other objects that also use this configuration.');
        this.set(props_id_1.PropsId.env, 'Environment variables applied to this container. Also contains variables defined in related ConfigMaps.');
        this.set(props_id_1.PropsId.resourceRoleMatrix, 'Matrix of granted Kubernetes RBAC rules.');
        this.set(props_id_1.PropsId.resources, {
            owner: (_a = {},
                _a[node_kind_1.NodeKind.ns] = 'Resource usage for all pod replicas within the namespace.',
                _a[node_kind_1.NodeKind.app] = 'Resource usage for all pod replicas within the application.',
                _a[node_kind_1.NodeKind.initcont] = 'Resource usage for a single container.',
                _a[node_kind_1.NodeKind.cont] = 'Resource usage for a single container.',
                _a[node_kind_1.NodeKind.node] = 'Resources provided by this node.',
                _a),
            default: 'Resource usage.'
        });
        this.set(props_id_1.PropsId.resourcesPerPod, 'Resource usage per single pod.');
        this.set(props_id_1.PropsId.clusterConsumption, 'Consumption of overall cluster resources.');
        this.set(props_id_1.PropsId.poolResources, 'Resources provided by nodes within the node pool.');
        this.set(props_id_1.PropsId.clusterResources, 'Resources provided by all nodes within the cluster.');
        this.set(props_id_1.PropsId.nodeResources, 'Resources provided by a single node. Describes the weakest node in the cluster.');
        this.set(props_id_1.PropsId.appConsumption, 'List of apps and resources they consume. Apps that tame most resources are on the top.');
        this.set(props_id_1.PropsId.ingressApp, 'Ingress network policy rules that allow or deny traffic from other applications.');
        this.set(props_id_1.PropsId.ingressCidr, 'Ingress network policy rules that allow or deny traffic from CIDR blocks.');
        this.set(props_id_1.PropsId.egressApp, 'Egress network policy rules that allow or deny traffic to other applications.');
        this.set(props_id_1.PropsId.egressCidr, 'Egress network policy rules that allow or deny traffic to CIDR blocks.');
        this.set(props_id_1.PropsId.ruleAssistant, 'Controls, tips and snippets to define custom rules for this configuration.');
        this.set(props_id_1.PropsId.health, 'Workload health metrics.');
        this.set(props_id_1.PropsId.podStages, 'Track health of pods across different versions.');
    }
    PropsTooltips.prototype.set = function (key, value) {
        this._values[key] = value;
    };
    PropsTooltips.prototype.get = function (key) {
        var value = this._values[key];
        if (!value) {
            return null;
        }
        return value;
    };
    return PropsTooltips;
}());
exports.PropsTooltips = PropsTooltips;
exports.PROPS_TOOLTIPS = new PropsTooltips();
//# sourceMappingURL=props-tooltips.js.map