"use strict";
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
exports.DEFAULT_VALIDATION_CONFIG = void 0;
var validator_id_1 = require("./validator-id");
var validation_config_1 = require("./validation-config");
exports.DEFAULT_VALIDATION_CONFIG = (_a = {},
    _a[validator_id_1.ValidatorID.API_SERVICE_DISCONNECTED] = validation_config_1.ValidatorSetting.warn,
    _a[validator_id_1.ValidatorID.API_SERVICE_CONNECTION_ERROR] = validation_config_1.ValidatorSetting.error,
    _a[validator_id_1.ValidatorID.MISSING_ROLE] = validation_config_1.ValidatorSetting.error,
    _a[validator_id_1.ValidatorID.MISSING_BINDING_TO_SERVICE_ACCOUNT] = validation_config_1.ValidatorSetting.error,
    _a[validator_id_1.ValidatorID.MISSING_CONTAINER_TO_SERVICE_ACCOUNT] = validation_config_1.ValidatorSetting.error,
    _a[validator_id_1.ValidatorID.MISSING_PSP] = validation_config_1.ValidatorSetting.error,
    _a[validator_id_1.ValidatorID.MISSING_VOLUME_MOUNT_CONFIG_MAP] = validation_config_1.ValidatorSetting.error,
    _a[validator_id_1.ValidatorID.MISSING_ENV_CONFIG_MAP] = validation_config_1.ValidatorSetting.error,
    _a[validator_id_1.ValidatorID.MISSING_ENV_CONFIG_MAP_KEY] = validation_config_1.ValidatorSetting.error,
    _a[validator_id_1.ValidatorID.MISSING_VOLUME_MOUNT_SECRET] = validation_config_1.ValidatorSetting.error,
    _a[validator_id_1.ValidatorID.MISSING_ENV_SECRET] = validation_config_1.ValidatorSetting.error,
    _a[validator_id_1.ValidatorID.MISSING_ENV_SECRET_KEY] = validation_config_1.ValidatorSetting.error,
    _a[validator_id_1.ValidatorID.MISSING_SVC_ACCOUNT_SECRET] = validation_config_1.ValidatorSetting.error,
    _a[validator_id_1.ValidatorID.MISSING_PVC] = validation_config_1.ValidatorSetting.error,
    _a[validator_id_1.ValidatorID.MISSING_PV] = validation_config_1.ValidatorSetting.error,
    _a[validator_id_1.ValidatorID.MISSING_HPA_APP] = validation_config_1.ValidatorSetting.error,
    _a[validator_id_1.ValidatorID.MISSING_SERVICE_APP] = validation_config_1.ValidatorSetting.error,
    _a[validator_id_1.ValidatorID.MISSING_INGRESS_SERVICE] = validation_config_1.ValidatorSetting.error,
    _a[validator_id_1.ValidatorID.MISSING_INGRESS_SERVICE_PORT] = validation_config_1.ValidatorSetting.error,
    _a[validator_id_1.ValidatorID.EMPTY_ENV_CONFIG_MAP] = validation_config_1.ValidatorSetting.off,
    _a[validator_id_1.ValidatorID.EMPTY_ENV_SECRET] = validation_config_1.ValidatorSetting.off,
    _a[validator_id_1.ValidatorID.UNSET_SERVICE_ACCOUNT] = validation_config_1.ValidatorSetting.off,
    _a[validator_id_1.ValidatorID.UNOWNED_REPLICA_SET] = validation_config_1.ValidatorSetting.warn,
    _a[validator_id_1.ValidatorID.UNOWNED_POD] = validation_config_1.ValidatorSetting.warn,
    _a[validator_id_1.ValidatorID.SERVICE_MULTIPLE_APPS] = validation_config_1.ValidatorSetting.warn,
    _a[validator_id_1.ValidatorID.SERVICE_MISSING_PORT] = validation_config_1.ValidatorSetting.error,
    _a[validator_id_1.ValidatorID.INGRESS_NOT_MOUNT_TO_APPS] = validation_config_1.ValidatorSetting.error,
    _a[validator_id_1.ValidatorID.UNUSED_CONFIG_MAP] = validation_config_1.ValidatorSetting.warn,
    _a[validator_id_1.ValidatorID.UNUSED_SECRET] = validation_config_1.ValidatorSetting.warn,
    _a[validator_id_1.ValidatorID.UNUSED_SERVICE_ACCOUNT] = validation_config_1.ValidatorSetting.warn,
    _a[validator_id_1.ValidatorID.UNUSED_ROLE_BINDING] = validation_config_1.ValidatorSetting.warn,
    _a[validator_id_1.ValidatorID.UNUSED_ROLE] = validation_config_1.ValidatorSetting.warn,
    _a[validator_id_1.ValidatorID.UNUSED_PVC] = validation_config_1.ValidatorSetting.warn,
    _a[validator_id_1.ValidatorID.UNUSED_PV] = validation_config_1.ValidatorSetting.warn,
    _a[validator_id_1.ValidatorID.POD_LIFECYCLE] = validation_config_1.ValidatorSetting.error,
    _a[validator_id_1.ValidatorID.POD_STATUS_NOT_SCHEDULED] = validation_config_1.ValidatorSetting.error,
    _a[validator_id_1.ValidatorID.POD_STATUS_NOT_CONTAINERS_READY] = validation_config_1.ValidatorSetting.error,
    _a[validator_id_1.ValidatorID.POD_STATUS_NOT_INITIALIZED] = validation_config_1.ValidatorSetting.error,
    _a[validator_id_1.ValidatorID.POD_STATUS_NOT_READY] = validation_config_1.ValidatorSetting.error,
    _a[validator_id_1.ValidatorID.POD_STATUS_OTHER_CONDITION] = validation_config_1.ValidatorSetting.error,
    _a[validator_id_1.ValidatorID.TRAEFIK_MISSING_MIDDLEWARE] = validation_config_1.ValidatorSetting.error,
    _a[validator_id_1.ValidatorID.TRAEFIK_MISSING_SERVICE] = validation_config_1.ValidatorSetting.error,
    _a[validator_id_1.ValidatorID.TRAEFIK_MISSING_TLS_OPTIONS] = validation_config_1.ValidatorSetting.error,
    _a[validator_id_1.ValidatorID.TRAEFIK_UNUSED_MIDDLEWARE] = validation_config_1.ValidatorSetting.warn,
    _a[validator_id_1.ValidatorID.TRAEFIK_UNUSED_SERVICE] = validation_config_1.ValidatorSetting.warn,
    _a[validator_id_1.ValidatorID.TRAEFIK_UNUSED_TLS_OPTIONS] = validation_config_1.ValidatorSetting.warn,
    _a);
//# sourceMappingURL=default-config.js.map