import { ValidatorID as ID } from '../validator-id';
import { ValidatorCategory, ValidatorSubCategory } from './categories';
export declare class ValidatorsDocsBuilder {
    private _data;
    validator(id: ID): ValidatorDocsBuilder;
    get(id: ID): ValidatorDocs;
    private _buildNewDocs;
}
export declare class ValidatorDocsBuilder {
    private _data;
    constructor(data: ValidatorDocs);
    category(value: ValidatorCategory): this;
    subCategory(value: ValidatorSubCategory): this;
    title(value: string): this;
    description(value: string): this;
    externalLink(value: string): this;
    example(value: string, language?: ValidatorExampleScriptLanguage): this;
    affected(value: string): this;
    affectedAllWorkloads(): this;
    resolution(value: string): this;
    resolutionExample(value: string, language?: ValidatorExampleScriptLanguage): this;
    resolutionAndExample(text: string, script: string, language?: ValidatorExampleScriptLanguage): this;
    private _massageScript;
}
export type ValidatorExampleScriptLanguage = 'javascript' | 'yaml' | 'json' | 'shell';
export interface ValidatorExample {
    language: ValidatorExampleScriptLanguage;
    script: string;
}
export interface ValidatorDocs {
    validatorId: ID;
    category: ValidatorCategory;
    subCategory: ValidatorSubCategory;
    title: string;
    description?: string;
    examples: ValidatorExample[];
    affected: string[];
    resolutions: string[];
    resolutionExamples: ValidatorExample[];
    externalLinks: string[];
}
//# sourceMappingURL=builder.d.ts.map