"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ExecutionState = void 0;
var entity_meta_1 = require("@kubevious/entity-meta");
var ExecutionState = /** @class */ (function () {
    function ExecutionState(state) {
        this._state = state;
        this._k8sApiResources = new entity_meta_1.K8sApiResourceStatusLoader();
        var k8sInfraDn = "".concat(entity_meta_1.NodeKind.root, "/").concat(entity_meta_1.NodeKind.infra, "/").concat(entity_meta_1.NodeKind.k8s);
        var k8sInfraNode = this._state.getNode(k8sInfraDn);
        if (!k8sInfraNode) {
            console.error('[ExecutionState] Node Not Present: ', k8sInfraDn);
            return;
        }
        var propsConfig = this._state.getProperties(k8sInfraDn, entity_meta_1.PropsId.config);
        var k8sApiResourceStatusConfig = (propsConfig !== null && propsConfig !== void 0 ? propsConfig : {}).config;
        try {
            this._k8sApiResources.load(k8sApiResourceStatusConfig);
        }
        catch (reason) {
            console.error('[ExecutionState] ERROR: ', reason);
        }
    }
    Object.defineProperty(ExecutionState.prototype, "state", {
        get: function () {
            return this._state;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ExecutionState.prototype, "k8sApiResources", {
        get: function () {
            return this._k8sApiResources;
        },
        enumerable: false,
        configurable: true
    });
    return ExecutionState;
}());
exports.ExecutionState = ExecutionState;
//# sourceMappingURL=execution-state.js.map