"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Evaluator = void 0;
var the_lodash_1 = __importDefault(require("the-lodash"));
var Evaluator = /** @class */ (function () {
    function Evaluator(targetSelector, prev, item, matchers) {
        this._targetSelector = targetSelector;
        this._prev = prev;
        this._item = item;
        this._matchers = matchers;
    }
    Evaluator.prototype.doesAnyMatch = function (valueCb) {
        if (this._matchers.length == 0) {
            return true;
        }
        var values = this._resolveValues();
        for (var _i = 0, values_1 = values; _i < values_1.length; _i++) {
            var value = values_1[_i];
            var isMatch = valueCb(value);
            if (isMatch) {
                return true;
            }
        }
        return false;
    };
    Evaluator.prototype._resolveValues = function () {
        var _this = this;
        var funcMatchers = this._matchers.filter(function (x) { return the_lodash_1.default.isFunction(x); });
        var matcherValues = this._matchers.filter(function (x) { return !the_lodash_1.default.isFunction(x); });
        var funcValues = funcMatchers.map(function (x) { return _this._resolveMatcherValue(x); });
        return the_lodash_1.default.concat(matcherValues, funcValues);
    };
    Evaluator.prototype._resolveMatcherValue = function (funcMatcher) {
        var params = {
            prev: this._prev,
            item: this._item,
        };
        return funcMatcher(params);
    };
    return Evaluator;
}());
exports.Evaluator = Evaluator;
//# sourceMappingURL=evaluator.js.map