import { FinalItems } from '../query/fetcher';
import { RegistryAccessor } from '@kubevious/state-registry';
export interface RuleObj {
    target: string;
    script: string;
}
export interface MessageInfo {
    msg: string;
    source: string[];
}
export interface ExecuteResult {
    success: boolean;
    targetItems: FinalItems[];
    messages: MessageInfo[];
    ruleItems: {
        [dn: string]: {
            errors?: {
                present: boolean;
                messages: string[];
            };
            warnings?: {
                present: boolean;
                messages: string[];
            };
            marks?: string[];
        };
    };
}
export declare class RuleProcessor {
    private _state;
    private _ruleTargetSrc;
    private _ruleScriptSrc;
    private _executeResult;
    private _messageHashes;
    private _targetProcessor?;
    private _validationProcessor?;
    private _executionState;
    constructor(state: RegistryAccessor, rule: RuleObj);
    process(): Promise<ExecuteResult>;
    private _prepare;
    private _execute;
    private _prepareTargets;
    private _prepareScript;
    private _executeTarget;
    private _executeValidators;
    private _executeValidator;
    private _getRuleItem;
    private _hasError;
    private _acceptScriptErrors;
    private _getExecuteResult;
}
//# sourceMappingURL=processor.d.ts.map