import { NodeKind, PropsId } from '@kubevious/entity-meta';
import { RegistryAccessor } from '@kubevious/state-registry';
export declare class ScriptItem {
    _dn: string;
    private _kind;
    _state: RegistryAccessor;
    constructor(dn: string, state: RegistryAccessor);
    get parent(): ScriptItem | null;
    get kind(): NodeKind | null;
    get node(): import("@kubevious/state-registry").SnapshotNodeConfig | null;
    get name(): string | null | undefined;
    get props(): any;
    get config(): any;
    get labels(): any;
    get annotations(): any;
    children(kind: string): ScriptItem[];
    hasChildren(kind: string): boolean;
    descendants(kind: string): ScriptItem[];
    hasDescendants(kind: string): boolean;
    ancestors(kind: string): ScriptItem[];
    links(linkOrNone?: string): ScriptItem[];
    hasLinks(linkOrNone?: string): boolean;
    getProperties(id: PropsId): any;
}
export type TargetLinksConfig = {
    [link: string]: {
        dn: string;
    }[];
};
//# sourceMappingURL=script-item.d.ts.map