"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.makeTargetRootScope = void 0;
var the_lodash_1 = __importDefault(require("the-lodash"));
var entity_meta_1 = require("@kubevious/entity-meta");
var k8s_target_1 = require("../../spec/target/root/k8s-target");
var types_1 = require("../../spec/target/root/types");
function makeTargetRootScope(rootScopeBuilder, scope, executionState) {
    var _loop_1 = function (x) {
        rootScopeBuilder.setup(x, function () {
            return scope.child(types_1.TOP_LEVEL_GRAPH_ROOTS[x]);
        });
    };
    for (var _i = 0, _a = the_lodash_1.default.keys(types_1.TopLevelQuery); _i < _a.length; _i++) {
        var x = _a[_i];
        _loop_1(x);
    }
    rootScopeBuilder.setup(types_1.TopLevelQuery.select, function (kind) {
        return scope.child(entity_meta_1.NodeKind.logic)
            .descendant(kind);
    });
    rootScopeBuilder.setup(types_1.TopLevelQuery.ApiVersion, function (apiVersion) {
        var target = new k8s_target_1.K8sTarget(scope, executionState);
        return target.ApiVersion(apiVersion);
    });
    rootScopeBuilder.setup(types_1.TopLevelQuery.Api, function (apiOrNone) {
        var target = new k8s_target_1.K8sTarget(scope, executionState);
        return target.Api(apiOrNone);
    });
}
exports.makeTargetRootScope = makeTargetRootScope;
//# sourceMappingURL=scope-builder.js.map