import { RegistryAccessor } from '@kubevious/state-registry';
import { ExecutionState } from '../execution-state';
import { ValidatorScopeBuilderExecutor } from '../scope-builders';
export interface ValidationProcessorResult {
    success?: boolean;
    messages?: string[];
    validation?: {
        hasErrors: boolean;
        hasWarnings: boolean;
        errorMsgs: {
            [name: string]: boolean;
        };
        warnMsgs: {
            [name: string]: boolean;
        };
        marks?: {
            [name: string]: boolean;
        };
    };
}
export declare class ValidationProcessor {
    private _runnable;
    private _src;
    private _executionState;
    private _scopeBuilderExecutor;
    constructor(src: string, executionState: ExecutionState, scopeBuilderExecutor?: ValidatorScopeBuilderExecutor);
    prepare(): Promise<{
        success: boolean;
        messages: never[];
    }>;
    private _loadModule;
    private _validate;
    execute(dn: string, state: RegistryAccessor): Promise<ValidationProcessorResult>;
    private _setupQueryBuilders;
    private _addError;
}
//# sourceMappingURL=processor.d.ts.map