"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.executeScopeQueryCount = exports.executeScopeQuerySingle = exports.executeScopeQueryMany = void 0;
var the_lodash_1 = __importDefault(require("the-lodash"));
var fetcher_1 = require("../../query/fetcher");
var script_item_1 = require("../../script-item");
function executeScopeQueryMany(scope, executionState) {
    scope.finalize();
    // console.log("[executeScopeQuery] ***** CHAIN LENGTH: ", scope._chain.length );
    // scope.debugOutput(2);
    // scope.validate(); // TODO:: 
    if (scope._chain.length == 0) {
        return [];
    }
    var fetcher = new fetcher_1.QueryFetcher(executionState, scope);
    var result = fetcher.execute();
    // console.log("[executeScopeQuery] MANY QUERY RESULT: ", result)
    if (!result.success) {
        return [];
    }
    return result.items.map(function (x) { return new script_item_1.ScriptItem(x.dn, executionState.state); });
}
exports.executeScopeQueryMany = executeScopeQueryMany;
function executeScopeQuerySingle(scope, executionState) {
    var items = executeScopeQueryMany(scope, executionState);
    return the_lodash_1.default.head(items);
}
exports.executeScopeQuerySingle = executeScopeQuerySingle;
function executeScopeQueryCount(scope, executionState) {
    var items = executeScopeQueryMany(scope, executionState);
    return items.length;
}
exports.executeScopeQueryCount = executeScopeQueryCount;
//# sourceMappingURL=scope-executor.js.map