"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.makeValidatorRootScope = void 0;
var the_lodash_1 = __importDefault(require("the-lodash"));
var types_1 = require("../../spec/target/root/types");
var scope_1 = require("./query/scope");
var k8s_target_1 = require("./query/k8s-target");
function makeValidatorRootScope(rootScopeBuilder, item, executionState) {
    var _loop_1 = function (x) {
        rootScopeBuilder.setup(x, function () {
            var scope = new scope_1.QueryableScope(executionState);
            return scope.child(types_1.TOP_LEVEL_GRAPH_ROOTS[x]);
        });
    };
    for (var _i = 0, _a = the_lodash_1.default.keys(types_1.TopLevelQuery); _i < _a.length; _i++) {
        var x = _a[_i];
        _loop_1(x);
    }
    rootScopeBuilder.setup(types_1.TopLevelQuery.ApiVersion, function (apiVersion) {
        var scope = new scope_1.QueryableScope(executionState);
        var target = new k8s_target_1.QueryableK8sTarget(scope, executionState, item);
        var builder = target.ApiVersion(apiVersion);
        return builder;
    });
    rootScopeBuilder.setup(types_1.TopLevelQuery.Api, function (apiOrNone) {
        var scope = new scope_1.QueryableScope(executionState);
        var target = new k8s_target_1.QueryableK8sTarget(scope, executionState, item);
        var builder = target.Api(apiOrNone);
        return builder;
    });
}
exports.makeValidatorRootScope = makeValidatorRootScope;
//# sourceMappingURL=scope-builder.js.map