import { Scope, KindType } from './scope';
import { GenericFilter, GenericFilterFunc, KeyValueDict, LogicLocationType } from './types';
export declare class LogicItem {
    _location: LogicLocationType;
    _params: LogicItemParams;
    _scope: Scope;
    _nameFilters: GenericFilter<string>[];
    _labelFilters: GenericFilter<KeyValueDict>[];
    _annotationFilters: GenericFilter<KeyValueDict>[];
    _customFilters: GenericFilterFunc<boolean>[];
    constructor(location: LogicLocationType, params: LogicItemParams);
    name(value: string): this;
    label(key: string, value: string): this;
    labels(value: KeyValueDict): this;
    annotation(key: string, value: string): this;
    annotations(value: KeyValueDict): this;
    filter(value: GenericFilterFunc<boolean>): this;
    descendant(kind: KindType): LogicItem;
    child(kind: KindType): LogicItem;
    parent(kindOrNone?: KindType): LogicItem;
    ancestor(kind: KindType): LogicItem;
    link(linkOrNone?: string): LogicItem;
    debugOutput(indent?: number): void;
}
export interface LogicItemParams {
    kind?: string | undefined;
    link?: string | undefined;
}
//# sourceMappingURL=logic-item.d.ts.map