import { Scope } from '../scope';
import { KeyValueDict } from '../types';
import { ExecutionState } from '../../../processors/execution-state';
export interface K8sTargetBuilderContext {
    namespace?: string;
}
export declare class K8sTargetBuilder {
    protected _scope: Scope;
    protected _executionState: ExecutionState;
    private _builderContext;
    private _data;
    constructor(scope: Scope, executionState: ExecutionState, builderContext: K8sTargetBuilderContext);
    ApiVersion(apiVersion: string): this;
    Api(apiOrNone?: string): this;
    Version(version: string): this;
    Kind(kind: string): this;
    namespace(value: string): this;
    allNamespaces(): this;
    name(value: string): this;
    label(key: string, value: string): this;
    labels(value: KeyValueDict): this;
    private _finalize;
}
export declare class K8sTarget {
    protected _scope: Scope;
    protected _executionState: ExecutionState;
    constructor(scope: Scope, executionState: ExecutionState);
    ApiVersion(apiVersion: string): K8sTargetBuilder;
    Api(apiOrNone?: string): K8sTargetBuilder;
    protected _makeTargetBuilder(): K8sTargetBuilder;
}
//# sourceMappingURL=k8s-target.d.ts.map