import { LogicItem, LogicItemParams } from './logic-item';
import { LogicLocationType } from './types';
export type KindType = string;
export type ScopeFinalizer = () => void;
export declare class Scope {
    _chain: (LogicItem)[];
    private _finalizers;
    constructor();
    descendant(kind: KindType): LogicItem;
    child(kind: KindType): LogicItem;
    parent(kindOrNone?: KindType): LogicItem;
    ancestor(kind: KindType): LogicItem;
    link(linkOrNone?: string): LogicItem;
    registerFinalizer(finalizer: ScopeFinalizer): void;
    finalize(): void;
    protected _add(location: LogicLocationType, params: LogicItemParams): LogicItem;
    protected _addToChain(item: LogicItem): LogicItem;
    debugOutput(indent?: number): void;
}
//# sourceMappingURL=scope.d.ts.map