"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RegistryBundleNode = void 0;
var RegistryBundleNode = /** @class */ (function () {
    function RegistryBundleNode(bundle, node) {
        this._selfAlertCount = { error: 0, warn: 0 };
        this._alertCount = { error: 0, warn: 0 };
        this._hierarchyAlerts = {};
        this._bundle = bundle;
        this._node = node;
        this._markers = node.markersDict;
        this._labels = node.getPropertiesConfig('labels');
        this._annotations = node.getPropertiesConfig('annotations');
    }
    Object.defineProperty(RegistryBundleNode.prototype, "kind", {
        get: function () {
            return this._node.kind;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RegistryBundleNode.prototype, "dn", {
        get: function () {
            return this._node.dn;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RegistryBundleNode.prototype, "config", {
        get: function () {
            return this._bundle.getNode(this.dn);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RegistryBundleNode.prototype, "registryNode", {
        get: function () {
            return this._node;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RegistryBundleNode.prototype, "selfAlerts", {
        get: function () {
            return this._node.selfAlerts;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RegistryBundleNode.prototype, "selfAlertCount", {
        get: function () {
            return this._selfAlertCount;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RegistryBundleNode.prototype, "alertCount", {
        get: function () {
            return this._alertCount;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RegistryBundleNode.prototype, "propertiesMap", {
        get: function () {
            return this.registryNode.propertiesMap;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RegistryBundleNode.prototype, "hierarchyAlerts", {
        get: function () {
            return this._hierarchyAlerts;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RegistryBundleNode.prototype, "labels", {
        get: function () {
            return this._labels;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RegistryBundleNode.prototype, "annotations", {
        get: function () {
            return this._annotations;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RegistryBundleNode.prototype, "markers", {
        get: function () {
            return this._markers;
        },
        enumerable: false,
        configurable: true
    });
    return RegistryBundleNode;
}());
exports.RegistryBundleNode = RegistryBundleNode;
//# sourceMappingURL=registry-bundle-node.js.map