import { RegistryBundleNode } from './registry-bundle-node';
import { RegistryState } from './registry-state';
import { AlertCounter } from './types/alert';
import { SnapshotNodeConfig } from './types/configs';
export declare class RegistryBundleState {
    private _registryState;
    private _nodeMap;
    private _nodeConfigs;
    constructor(registryState: RegistryState);
    get date(): Date;
    get registryState(): RegistryState;
    get nodeItems(): RegistryBundleNode[];
    getCount(): number;
    getNodeItem(dn: string): RegistryBundleNode | null;
    getNode(dn: string): BundledNodeConfig | null;
    getChildren(parentDn: string): BundledNodeConfig[];
    private _buildNodes;
    private _finalize;
    private _traverseTreeBottomsUp;
    private _traverseNodes;
}
export interface BundledNodeConfig extends SnapshotNodeConfig {
    childrenCount: number;
    markers: string[];
    selfAlertCount: AlertCounter;
    alertCount: AlertCounter;
}
//# sourceMappingURL=registry-bundle-state.d.ts.map