import { NodeKind } from '@kubevious/entity-meta';
import { RegistryState } from './registry-state';
import { ItemProperties } from './registry-accessor';
import { Alert } from './types/alert';
import { SnapshotNodeConfig, SnapshotPropsConfig } from './types/configs';
export declare class RegistryStateNode {
    private _state;
    private _dn;
    private _config;
    private _propertiesMap;
    private _selfAlerts;
    private _markers;
    constructor(state: RegistryState, dn: string, config: SnapshotNodeConfig, propertiesMap: ItemProperties, alerts: Alert[]);
    get dn(): string;
    get kind(): NodeKind;
    get rn(): string;
    get name(): string | undefined;
    get config(): SnapshotNodeConfig;
    get childrenCount(): number;
    get labels(): SnapshotPropsConfig;
    get annotations(): SnapshotPropsConfig;
    get selfAlerts(): Alert[];
    get markers(): string[];
    get markersDict(): Record<string, boolean>;
    get propertiesMap(): ItemProperties;
    getProperties(name: string): SnapshotPropsConfig | null;
    getPropertiesConfig(name: string): any;
    raiseMarker(name: string): void;
}
//# sourceMappingURL=registry-state-node.d.ts.map