"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RegistryStateNode = void 0;
var the_lodash_1 = __importDefault(require("the-lodash"));
var RegistryStateNode = /** @class */ (function () {
    function RegistryStateNode(state, dn, config, propertiesMap, alerts) {
        this._markers = {};
        this._state = state;
        this._dn = dn;
        this._config = config;
        this._propertiesMap = propertiesMap;
        this._selfAlerts = alerts;
    }
    Object.defineProperty(RegistryStateNode.prototype, "dn", {
        get: function () {
            return this._dn;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RegistryStateNode.prototype, "kind", {
        get: function () {
            return this.config.kind;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RegistryStateNode.prototype, "rn", {
        get: function () {
            return this.config.rn;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RegistryStateNode.prototype, "name", {
        get: function () {
            return this.config.name;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RegistryStateNode.prototype, "config", {
        get: function () {
            return this._config;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RegistryStateNode.prototype, "childrenCount", {
        get: function () {
            var childDns = this._state.getChildrenDns(this.dn);
            return childDns.length;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RegistryStateNode.prototype, "labels", {
        get: function () {
            var _a, _b;
            // TODO: validate logic
            // return this._propertiesMap['labels'] || {};
            return (_b = (_a = this._propertiesMap['labels']) === null || _a === void 0 ? void 0 : _a.config) !== null && _b !== void 0 ? _b : {};
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RegistryStateNode.prototype, "annotations", {
        get: function () {
            var _a, _b;
            // TODO: validate logic
            // return this._propertiesMap['annotations'] || {};
            return (_b = (_a = this._propertiesMap['annotations']) === null || _a === void 0 ? void 0 : _a.config) !== null && _b !== void 0 ? _b : {};
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RegistryStateNode.prototype, "selfAlerts", {
        get: function () {
            return this._selfAlerts;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RegistryStateNode.prototype, "markers", {
        get: function () {
            return the_lodash_1.default.keys(this._markers);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RegistryStateNode.prototype, "markersDict", {
        get: function () {
            return this._markers;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RegistryStateNode.prototype, "propertiesMap", {
        get: function () {
            return this._propertiesMap;
        },
        enumerable: false,
        configurable: true
    });
    RegistryStateNode.prototype.getProperties = function (name) {
        var props = this._propertiesMap[name];
        if (!props) {
            return null;
        }
        return props;
    };
    RegistryStateNode.prototype.getPropertiesConfig = function (name) {
        var props = this._propertiesMap[name];
        if (!props) {
            return {};
        }
        return props.config || {};
    };
    RegistryStateNode.prototype.raiseMarker = function (name) {
        this._markers[name] = true;
    };
    return RegistryStateNode;
}());
exports.RegistryStateNode = RegistryStateNode;
//# sourceMappingURL=registry-state-node.js.map