"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RegistryState = void 0;
var the_lodash_1 = __importDefault(require("the-lodash"));
var entity_meta_1 = require("@kubevious/entity-meta");
var registry_state_node_1 = require("./registry-state-node");
var registry_bundle_state_1 = require("./registry-bundle-state");
var configs_1 = require("./types/configs");
var RegistryState = /** @class */ (function () {
    function RegistryState(snapshotInfo) {
        this._nodeMap = {};
        this._childrenMap = {};
        this._propertiesMap = {};
        this._alertsMap = {};
        this._kindMap = {};
        if (!snapshotInfo.date) {
            this._date = new Date();
        }
        else {
            if (the_lodash_1.default.isString(snapshotInfo.date)) {
                this._date = new Date(snapshotInfo.date);
            }
            else {
                this._date = snapshotInfo.date;
            }
        }
        this._transform(snapshotInfo);
    }
    Object.defineProperty(RegistryState.prototype, "date", {
        get: function () {
            return this._date;
        },
        enumerable: false,
        configurable: true
    });
    RegistryState.prototype.getCount = function () {
        return the_lodash_1.default.keys(this._nodeMap).length;
    };
    RegistryState.prototype.getAllProperties = function (dn) {
        var _a;
        var allProps = (_a = this._getProperties(dn)) !== null && _a !== void 0 ? _a : {};
        return allProps;
    };
    RegistryState.prototype.getProperties = function (dn, id) {
        var _a, _b;
        var allProps = (_a = this._getProperties(dn)) !== null && _a !== void 0 ? _a : {};
        var props = (_b = allProps[id]) !== null && _b !== void 0 ? _b : {};
        return props || {};
    };
    RegistryState.prototype.getAlerts = function (dn) {
        var _a;
        var alerts = (_a = this._getAlerts(dn)) !== null && _a !== void 0 ? _a : [];
        return alerts;
    };
    RegistryState.prototype.getNodes = function () {
        return the_lodash_1.default.values(this._nodeMap);
    };
    RegistryState.prototype.getNodeDns = function () {
        return the_lodash_1.default.keys(this._nodeMap);
    };
    RegistryState.prototype.getNode = function (dn) {
        var node = this._nodeMap[dn];
        if (!node) {
            return null;
        }
        return node.config;
    };
    RegistryState.prototype.findByKind = function (kind) {
        var res = this._kindMap[kind];
        if (!res) {
            return {};
        }
        return res;
    };
    RegistryState.prototype.findByDn = function (dn) {
        var res = this._nodeMap[dn];
        if (!res) {
            return null;
        }
        return res;
    };
    RegistryState.prototype.countByKind = function (kind) {
        return the_lodash_1.default.keys(this.findByKind(kind)).length;
    };
    RegistryState.prototype.childrenByKind = function (parentDn, kind) {
        var newResult = {};
        var childDns = this._childrenMap[parentDn];
        if (childDns) {
            for (var _i = 0, childDns_1 = childDns; _i < childDns_1.length; _i++) {
                var childDn = childDns_1[_i];
                var childNode = this.getNode(childDn);
                if (childNode) {
                    if (childNode.kind == kind) {
                        newResult[childDn] = true;
                    }
                }
            }
        }
        return the_lodash_1.default.keys(newResult);
    };
    RegistryState.prototype.scopeByKind = function (ancestorDn, kind) {
        var result = this.findByKind(kind);
        var newResult = {};
        for (var _i = 0, _a = the_lodash_1.default.keys(result); _i < _a.length; _i++) {
            var key = _a[_i];
            if (the_lodash_1.default.startsWith(key, ancestorDn)) {
                newResult[key] = true;
            }
        }
        return the_lodash_1.default.keys(newResult);
    };
    RegistryState.prototype.countScopeByKind = function (ancestorDn, kind) {
        var result = this.findByKind(kind);
        var count = 0;
        for (var _i = 0, _a = the_lodash_1.default.keys(result); _i < _a.length; _i++) {
            var key = _a[_i];
            if (the_lodash_1.default.startsWith(key, ancestorDn)) {
                count++;
            }
        }
        return count;
    };
    RegistryState.prototype.scopeFlat = function (ancestorDn) {
        var nodes = this.getNodes();
        var newResult = nodes.filter(function (x) { return the_lodash_1.default.startsWith(x.dn, ancestorDn); });
        return newResult;
    };
    RegistryState.prototype.getChildrenDns = function (dn) {
        var childDns = this._childrenMap[dn];
        if (childDns) {
            return childDns;
        }
        return [];
    };
    RegistryState.prototype.addNewItem = function (item) {
        switch (item.config_kind) {
            case configs_1.SnapshotConfigKind.node:
                {
                    var config = item.config;
                    this._addTreeNode(item.dn, config);
                }
                break;
            case configs_1.SnapshotConfigKind.props:
                {
                    var config = item.config;
                    var props = this._fetchProperties(item.dn);
                    props[config.id] = config;
                }
                break;
            case configs_1.SnapshotConfigKind.alerts:
                {
                    var config = item.config;
                    var alerts = this._fetchAlerts(item.dn);
                    for (var _i = 0, config_1 = config; _i < config_1.length; _i++) {
                        var x = config_1[_i];
                        alerts.push(x);
                    }
                }
                break;
        }
    };
    RegistryState.prototype.extractSnapshotInfo = function () {
        var snapshotInfo = {
            date: this.date,
            items: []
        };
        for (var _i = 0, _a = this.getNodes(); _i < _a.length; _i++) {
            var node = _a[_i];
            snapshotInfo.items.push({
                dn: node.dn,
                kind: node.kind,
                config_kind: configs_1.SnapshotConfigKind.node,
                config: node.config
            });
            var props = this.getAllProperties(node.dn);
            for (var _b = 0, _c = the_lodash_1.default.values(props); _b < _c.length; _b++) {
                var prop = _c[_b];
                snapshotInfo.items.push({
                    dn: node.dn,
                    kind: node.kind,
                    config_kind: configs_1.SnapshotConfigKind.props,
                    config: prop
                });
            }
            var alerts = this.getAlerts(node.dn);
            if (alerts.length > 0) {
                snapshotInfo.items.push({
                    dn: node.dn,
                    kind: node.kind,
                    config_kind: configs_1.SnapshotConfigKind.alerts,
                    config: alerts
                });
            }
        }
        return snapshotInfo;
    };
    RegistryState.prototype._transform = function (snapshotInfo) {
        for (var _i = 0, _a = snapshotInfo.items; _i < _a.length; _i++) {
            var item = _a[_i];
            this.addNewItem(item);
        }
    };
    RegistryState.prototype._addTreeNode = function (dn, nodeConfig) {
        var node = new registry_state_node_1.RegistryStateNode(this, dn, nodeConfig, this._fetchProperties(dn), this._fetchAlerts(dn));
        this._nodeMap[dn] = node;
        if (!this._kindMap[nodeConfig.kind]) {
            this._kindMap[nodeConfig.kind] = {};
        }
        this._kindMap[nodeConfig.kind][dn] = node;
        this._registerChild(dn);
    };
    RegistryState.prototype._registerChild = function (dn) {
        var parent_dn = (0, entity_meta_1.parentDn)(dn);
        if (parent_dn) {
            var parent_1 = this._childrenMap[parent_dn];
            if (!parent_1) {
                parent_1 = [];
                this._childrenMap[parent_dn] = parent_1;
            }
            parent_1.push(dn);
        }
    };
    RegistryState.prototype._getProperties = function (dn) {
        var props = this._propertiesMap[dn];
        return props;
    };
    RegistryState.prototype._getAlerts = function (dn) {
        var alerts = this._alertsMap[dn];
        return alerts;
    };
    RegistryState.prototype._fetchProperties = function (dn) {
        var props = this._propertiesMap[dn];
        if (!props) {
            props = {};
            this._propertiesMap[dn] = props;
        }
        return props;
    };
    RegistryState.prototype._fetchAlerts = function (dn) {
        var alerts = this._alertsMap[dn];
        if (!alerts) {
            alerts = [];
            this._alertsMap[dn] = alerts;
        }
        return alerts;
    };
    RegistryState.prototype.raiseAlert = function (dn, alertInfo) {
        var alerts = this._fetchAlerts(dn);
        alerts.push(alertInfo);
    };
    RegistryState.prototype.raiseMarker = function (dn, name) {
        var node = this._nodeMap[dn];
        if (!node) {
            return;
        }
        node.raiseMarker(name);
    };
    RegistryState.prototype.postProcessAlerts = function (cb) {
        for (var _i = 0, _a = the_lodash_1.default.keys(this._alertsMap); _i < _a.length; _i++) {
            var dn = _a[_i];
            cb(dn, this._alertsMap[dn]);
        }
    };
    RegistryState.prototype.buildBundle = function () {
        if (this._stateBundle) {
            throw new Error("Is already bundled");
        }
        var newBundleState = new registry_bundle_state_1.RegistryBundleState(this);
        this._stateBundle = newBundleState;
        return newBundleState;
    };
    RegistryState.prototype.debugOutputToDir = function (logger, relPath) {
        return __awaiter(this, void 0, void 0, function () {
            var _i, _a, dn, filePath, node, _b, _c, dn, filePath, children, _d, _e, dn, propsMap, _f, _g, propName, props, filePath, _h, _j, dn, filePath, alerts;
            return __generator(this, function (_k) {
                switch (_k.label) {
                    case 0:
                        _i = 0, _a = the_lodash_1.default.keys(this._nodeMap);
                        _k.label = 1;
                    case 1:
                        if (!(_i < _a.length)) return [3 /*break*/, 4];
                        dn = _a[_i];
                        filePath = "".concat(relPath, "/").concat((0, entity_meta_1.sanitizeDnPath)(dn), "/node.json");
                        node = this._nodeMap[dn];
                        return [4 /*yield*/, logger.outputFile(filePath, node.config)];
                    case 2:
                        _k.sent();
                        _k.label = 3;
                    case 3:
                        _i++;
                        return [3 /*break*/, 1];
                    case 4:
                        _b = 0, _c = the_lodash_1.default.keys(this._childrenMap);
                        _k.label = 5;
                    case 5:
                        if (!(_b < _c.length)) return [3 /*break*/, 8];
                        dn = _c[_b];
                        filePath = "".concat(relPath, "/").concat((0, entity_meta_1.sanitizeDnPath)(dn), "/children.json");
                        children = this._childrenMap[dn];
                        return [4 /*yield*/, logger.outputFile(filePath, children)];
                    case 6:
                        _k.sent();
                        _k.label = 7;
                    case 7:
                        _b++;
                        return [3 /*break*/, 5];
                    case 8:
                        _d = 0, _e = the_lodash_1.default.keys(this._propertiesMap);
                        _k.label = 9;
                    case 9:
                        if (!(_d < _e.length)) return [3 /*break*/, 14];
                        dn = _e[_d];
                        propsMap = this._propertiesMap[dn];
                        _f = 0, _g = the_lodash_1.default.keys(propsMap);
                        _k.label = 10;
                    case 10:
                        if (!(_f < _g.length)) return [3 /*break*/, 13];
                        propName = _g[_f];
                        props = propsMap[propName];
                        filePath = "".concat(relPath, "/").concat((0, entity_meta_1.sanitizeDnPath)(dn), "/props-").concat(props.id, ".json");
                        return [4 /*yield*/, logger.outputFile(filePath, props)];
                    case 11:
                        _k.sent();
                        _k.label = 12;
                    case 12:
                        _f++;
                        return [3 /*break*/, 10];
                    case 13:
                        _d++;
                        return [3 /*break*/, 9];
                    case 14:
                        _h = 0, _j = the_lodash_1.default.keys(this._alertsMap);
                        _k.label = 15;
                    case 15:
                        if (!(_h < _j.length)) return [3 /*break*/, 18];
                        dn = _j[_h];
                        filePath = "".concat(relPath, "/").concat((0, entity_meta_1.sanitizeDnPath)(dn), "/alerts.json");
                        alerts = this._alertsMap[dn];
                        if (!(alerts.length > 0)) return [3 /*break*/, 17];
                        return [4 /*yield*/, logger.outputFile(filePath, alerts)];
                    case 16:
                        _k.sent();
                        _k.label = 17;
                    case 17:
                        _h++;
                        return [3 /*break*/, 15];
                    case 18: return [2 /*return*/];
                }
            });
        });
    };
    return RegistryState;
}());
exports.RegistryState = RegistryState;
//# sourceMappingURL=registry-state.js.map