import { Options as AjvOptions } from "ajv";
import { RequestHandler } from "express";
import OpenApiDocument, { Operation } from "./OpenApiDocument";
export interface ValidatorConfig {
    ajvOptions?: AjvOptions;
}
export interface PathRegexpObject {
    path: string;
    regex: RegExp;
}
export interface MatchOptions {
    allowNoMatch?: boolean;
}
export default class OpenApiValidator {
    private _ajv;
    private _document;
    constructor(openApiDocument: OpenApiDocument, options?: ValidatorConfig);
    validate(method: Operation, path: string): RequestHandler;
    match(options?: MatchOptions): RequestHandler;
    validateResponse(method: Operation, path: string): (res: any) => void;
    private _getResponseObject;
    private _getPathItemObject;
    private _getOperationObject;
}
//# sourceMappingURL=OpenApiValidator.d.ts.map