import { ILogger } from 'the-logger';
import { KubernetesClient } from './client';
import { ApiGroupInfo } from './types';
export declare class ClusterInfoFetcher {
    private logger;
    private _client;
    private _rootApiVersion;
    private _apiGroups;
    private _selectedApiGroups;
    private _enabledApiGroups;
    private _preferredVersions;
    constructor(logger: ILogger, client: KubernetesClient);
    perform(): Promise<ClusterInfo>;
    private _discoverRootApi;
    private _discoverApiGroups;
    private _fetchApiGroup;
    private _setupApiGroup;
    private _finalizeApis;
    private _selectApiGroupVersion;
    private _getPreferredVersion;
    private _finalizeApi;
    private _isApiDisabled;
}
export interface ClusterInfo {
    rootApiVersion: string;
    apiGroups: ApiGroupInfo[];
    enabledApiGroups: Record<string, ApiGroupInfo>;
    preferredVersions: Record<string, string>;
}
//# sourceMappingURL=cluster-info-fetcher.d.ts.map