"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.connectRemoteCluster = exports.connectDefaultRemoteCluster = void 0;
var the_lodash_1 = __importDefault(require("the-lodash"));
var dotenv_1 = __importDefault(require("dotenv"));
var client_node_1 = require("@kubernetes/client-node");
var client_1 = require("./client");
dotenv_1.default.config();
function connectDefaultRemoteCluster(logger, params) {
    var _a;
    return __awaiter(this, void 0, void 0, function () {
        var kubeConfigPath;
        return __generator(this, function (_b) {
            kubeConfigPath = (_a = process.env.KUBECONFIG) !== null && _a !== void 0 ? _a : "".concat(process.env.HOME, "/.kube/config");
            return [2 /*return*/, connectRemoteCluster(logger, kubeConfigPath, process.env.KUBE_CONTEXT_NAME, params)];
        });
    });
}
exports.connectDefaultRemoteCluster = connectDefaultRemoteCluster;
function connectRemoteCluster(logger, kubeConfigPath, overrideKubeConfigContext, params) {
    var _a, _b, _c, _d;
    return __awaiter(this, void 0, void 0, function () {
        var kubeConfig, cluster, skipTLSVerify, requestOptions, k8sLogger, clientConfig, parts, client;
        return __generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    params = params || {};
                    params.skipAPIFetch = (_a = params.skipAPIFetch) !== null && _a !== void 0 ? _a : false;
                    params.skipTLSVerify = (_b = params.skipTLSVerify) !== null && _b !== void 0 ? _b : false;
                    logger.info("KUBE CONFIG FILE: %s", kubeConfigPath);
                    kubeConfig = new client_node_1.KubeConfig();
                    kubeConfig.loadFromFile(kubeConfigPath);
                    if (overrideKubeConfigContext) {
                        kubeConfig.currentContext = overrideKubeConfigContext;
                    }
                    cluster = kubeConfig.getCurrentCluster();
                    if (!cluster) {
                        throw new Error("Invalid cluster config: ".concat(kubeConfigPath));
                    }
                    skipTLSVerify = false || cluster.skipTLSVerify || params.skipTLSVerify;
                    requestOptions = {};
                    kubeConfig.applytoHTTPSOptions(requestOptions);
                    k8sLogger = logger.sublogger('k8s');
                    clientConfig = {
                        server: cluster.server,
                        httpAgent: {
                            ca: requestOptions.ca,
                            cert: requestOptions.cert,
                            key: requestOptions.key,
                            rejectUnauthorized: skipTLSVerify
                        }
                    };
                    if ((_c = requestOptions.headers) === null || _c === void 0 ? void 0 : _c.Authorization) {
                        parts = (_d = requestOptions.headers) === null || _d === void 0 ? void 0 : _d.Authorization.toString().split(' ');
                        clientConfig.token = the_lodash_1.default.last(parts);
                    }
                    client = new client_1.KubernetesClient(k8sLogger, clientConfig);
                    if (!!(params === null || params === void 0 ? void 0 : params.skipAPIFetch)) return [3 /*break*/, 2];
                    return [4 /*yield*/, client.init()];
                case 1:
                    _e.sent();
                    _e.label = 2;
                case 2: return [2 /*return*/, client];
            }
        });
    });
}
exports.connectRemoteCluster = connectRemoteCluster;
//# sourceMappingURL=connector-remote.js.map