import { ILogger } from 'the-logger';
import { K8sApiJsonSchema } from './types';
import { OpenApiV3SchemaObject } from '../open-api-v3-types';
import { K8sOpenApiResource } from '../types';
export declare class BaseOpenApiDocumentParser {
    protected _logger: ILogger;
    private _documentSchemas;
    private _k8sApiData;
    private _convertedTargetRefs;
    constructor(logger: ILogger, k8sApiData: K8sApiJsonSchema, documentSchemas?: Record<string, OpenApiV3SchemaObject>);
    protected _convertApiResource(path: string, apiResource: K8sOpenApiResource, resourceRef: string): void;
    private _convertReference;
    private _convertSchema;
    private _convertProperties;
    private _convertArray;
    private _applyCustomFix;
    private _convertRef;
    private _getResourceKeyFromRef;
}
//# sourceMappingURL=base-open-api-document-parser.d.ts.map