"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OpenApiV2DocumentParser = void 0;
var the_lodash_1 = __importDefault(require("the-lodash"));
var base_open_api_document_parser_1 = require("./base-open-api-document-parser");
var OpenApiV2DocumentParser = /** @class */ (function (_super) {
    __extends(OpenApiV2DocumentParser, _super);
    function OpenApiV2DocumentParser(logger, k8sApiData, document) {
        var _this = _super.call(this, logger, k8sApiData, document.definitions) || this;
        _this._document = document;
        return _this;
    }
    OpenApiV2DocumentParser.prototype.convert = function () {
        for (var _i = 0, _a = the_lodash_1.default.keys(this._document.paths); _i < _a.length; _i++) {
            var path = _a[_i];
            var pathDict = this._document.paths[path];
            var methodDict = pathDict['post'];
            if (methodDict) {
                if (methodDict['x-kubernetes-action'] === 'post') {
                    var apiResource = methodDict['x-kubernetes-group-version-kind'];
                    if (apiResource) {
                        if (methodDict.parameters) {
                            var bodyParameter = the_lodash_1.default.find(methodDict.parameters, function (x) { return x.name === 'body'; });
                            if (bodyParameter) {
                                var reference = bodyParameter.schema['$ref'];
                                if (reference) {
                                    this._convertApiResource(path, apiResource, reference);
                                }
                            }
                        }
                    }
                }
            }
        }
    };
    return OpenApiV2DocumentParser;
}(base_open_api_document_parser_1.BaseOpenApiDocumentParser));
exports.OpenApiV2DocumentParser = OpenApiV2DocumentParser;
//# sourceMappingURL=open-api-v2-document-parser.js.map