"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OpenApiV3DocumentParser = void 0;
var the_lodash_1 = __importDefault(require("the-lodash"));
var base_open_api_document_parser_1 = require("./base-open-api-document-parser");
var OpenApiV3DocumentParser = /** @class */ (function (_super) {
    __extends(OpenApiV3DocumentParser, _super);
    function OpenApiV3DocumentParser(logger, k8sApiData, document) {
        var _this = _super.call(this, logger, k8sApiData, document.components.schemas) || this;
        _this._document = document;
        return _this;
    }
    OpenApiV3DocumentParser.prototype.convert = function () {
        var _a;
        for (var _i = 0, _b = the_lodash_1.default.keys(this._document.paths); _i < _b.length; _i++) {
            var path = _b[_i];
            var pathDict = this._document.paths[path];
            var methodDict = pathDict['post'];
            if (methodDict) {
                if (methodDict['x-kubernetes-action'] === 'post') {
                    var apiResource = methodDict['x-kubernetes-group-version-kind'];
                    if (apiResource) {
                        var contentDict = (_a = methodDict.requestBody) === null || _a === void 0 ? void 0 : _a.content;
                        if (contentDict) {
                            for (var _c = 0, _d = the_lodash_1.default.values(contentDict); _c < _d.length; _c++) {
                                var contentTypeDict = _d[_c];
                                var schemaDict = contentTypeDict.schema;
                                if (schemaDict) {
                                    var reference = schemaDict['$ref'];
                                    if (reference) {
                                        this._convertApiResource(path, apiResource, reference);
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    };
    return OpenApiV3DocumentParser;
}(base_open_api_document_parser_1.BaseOpenApiDocumentParser));
exports.OpenApiV3DocumentParser = OpenApiV3DocumentParser;
//# sourceMappingURL=open-api-v3-document-parser.js.map