import { KubernetesClient } from "../client";
import { KubernetesVersionInfo, K8sOpenApiSpecs } from "./types";
import { KubernetesOpenApiV3Response, KubernetesOpenApiV3Root } from './open-api-v3';
import { KubernetesOpenApiV2Root } from './open-api-v2';
export declare class KubernetesOpenApiClient {
    private _client;
    constructor(client: KubernetesClient);
    queryClusterVersionInfo(): Promise<KubernetesVersionInfo>;
    queryClusterVersion(): Promise<string>;
    queryV3RootPaths(): Promise<KubernetesOpenApiV3Root>;
    queryV3AllPaths(): Promise<Record<string, KubernetesOpenApiV3Response>>;
    queryV2Root(): Promise<KubernetesOpenApiV2Root>;
    queryApiSpecs(options?: QueryApiSpecsOptions): Promise<K8sOpenApiSpecs>;
    private _queryApiSpecsV3;
    private _queryApiSpecsV2;
}
export interface QueryApiSpecsOptions {
    forceApiV2?: boolean;
    forceApiV3?: boolean;
}
//# sourceMappingURL=open-api-client.d.ts.map