import { ILogger } from 'the-logger';
import { ResourceAccessor, ResourceScope } from './resource-accessor';
import { KubernetesObject } from './types';
export type WatchCallback = (action: DeltaAction, data: KubernetesObject) => void;
export type ConnectCallback = (resourceAccessor: ResourceAccessor) => void;
export type DisconnectCallback = (resourceAccessor: ResourceAccessor, reason: {}) => void;
export type CloseCallback = () => void;
export declare class ResourceWatch {
    private _logger;
    private _resourceAccessor;
    private _namespace;
    private _snapshot;
    private _newSnapshot;
    private _recovering;
    private _isScheduled;
    private _scheduleTimeout;
    private _isStopped;
    private _stream;
    private _isDisconnected;
    private _cb;
    private _connectCb;
    private _disconnectCb;
    private _closeCb;
    private _waitCloseResolveCb;
    private _scope;
    private _runWatchTimer;
    private _recoveryTimer;
    private _name;
    constructor(logger: ILogger, resourceAccessor: ResourceAccessor, namespace: string | null, cb: WatchCallback, connectCb: ConnectCallback, disconnectCb: DisconnectCallback, closeCb: CloseCallback, scope: ResourceScope);
    get logger(): ILogger;
    get name(): string;
    start(): void;
    stop(): void;
    close(): void;
    waitClose(): Promise<void>;
    private _closeStream;
    private _runWatch;
    private _handleChange;
    private _applyToSnapshot;
    private _onDisconnect;
    private _tryReconnect;
    private _scheduleRunWatch;
    private _scheduleRecoveryTimer;
    private _handleRecovery;
    private _stopRunWatchTimer;
    private _stopRecoveryTimer;
    private _produceDelta;
}
export declare enum DeltaAction {
    Added = "ADDED",
    Modified = "MODIFIED",
    Deleted = "DELETED"
}
//# sourceMappingURL=resource-watch.d.ts.map