export interface ApiGroupInfo {
    id: string;
    apiVersion: string;
    apiName: string | null;
    version: string;
    kindName: string;
    pluralName: string;
    isNamespaced: boolean;
    verbs: string[];
    allVersions: string[];
    isEnabled: boolean;
}
export interface KubernetesObject {
    kind: string;
    apiVersion: string;
    metadata: {
        name: string;
        namespace?: string;
        labels?: Record<string, string>;
        annotations?: Record<string, string>;
        [x: string]: any;
    };
    spec?: object;
    status?: object;
    data?: object;
    [x: string]: any;
}
export declare class KubernetesError extends Error {
    code: number;
    constructor(message: string, code: number);
}
//# sourceMappingURL=types.d.ts.map