"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.isDefaultedEqual = void 0;
var _ = __importStar(require("lodash"));
var null_1 = require("./null");
var make_dict_1 = require("./make-dict");
var stable_stringify_1 = require("./stable-stringify");
function defaultKeySelector(x) {
    if (typeof x === 'undefined') {
        return 'not-defined';
    }
    if (x && typeof x == 'object') {
        return (0, stable_stringify_1.stableStringify)(x);
    }
    return x;
}
function defaultValueSelector(x) {
    return x;
}
function equal(a, b, path, arrayMeta, skipAddPath) {
    if (a === b)
        return true;
    if (a && typeof a == 'object') {
        if ((0, null_1.isNullOrUndefined)(b)) {
            return true;
        }
        if (b && typeof b == 'object') {
            var arrA = _.isArray(a), arrB = _.isArray(b), i, length, key;
            if (arrA && arrB) {
                if (a.length != b.length) {
                    return false;
                }
                if (path in arrayMeta) {
                    var propMeta = arrayMeta[path];
                    if (!propMeta) {
                        propMeta = {};
                    }
                    var keySelector;
                    if (propMeta.keySelector) {
                        keySelector = propMeta.keySelector;
                    }
                    else {
                        keySelector = defaultKeySelector;
                    }
                    var valueSelector;
                    if (propMeta.valueSelector) {
                        valueSelector = propMeta.valueSelector;
                    }
                    else {
                        valueSelector = defaultValueSelector;
                    }
                    var dictA = (0, make_dict_1.makeDict)(a, keySelector, valueSelector);
                    var dictB = (0, make_dict_1.makeDict)(b, keySelector, valueSelector);
                    var currPath;
                    if (path) {
                        currPath = path + '.[]';
                    }
                    else {
                        currPath = '[]';
                    }
                    return equal(dictA, dictB, currPath, arrayMeta, true);
                }
                for (i = a.length; i-- !== 0;)
                    if (!equal(a[i], b[i], path, arrayMeta))
                        return false;
                return true;
            }
            if (arrA != arrB) {
                return false;
            }
            var dateA = a instanceof Date, dateB = b instanceof Date;
            if (dateA != dateB)
                return false;
            if (dateA && dateB)
                return a.getTime() == b.getTime();
            var regexpA = a instanceof RegExp, regexpB = b instanceof RegExp;
            if (regexpA != regexpB)
                return false;
            if (regexpA && regexpB)
                return a.toString() == b.toString();
            var keysA = _.keys(a);
            for (i = keysA.length; i-- !== 0;) {
                key = keysA[i];
                if (Object.prototype.hasOwnProperty.call(b, key)) {
                    var currPath;
                    if (skipAddPath) {
                        currPath = path;
                    }
                    else {
                        if (path) {
                            currPath = path + '.' + key;
                        }
                        else {
                            currPath = key;
                        }
                    }
                    if (!equal(a[key], b[key], currPath, arrayMeta)) {
                        return false;
                    }
                }
            }
            var keysB = _.keys(b);
            for (i = keysB.length; i-- !== 0;) {
                key = keysB[i];
                if (!Object.prototype.hasOwnProperty.call(a, key)) {
                    return false;
                }
            }
            return true;
        }
    }
    return a !== a && b !== b;
}
function isDefaultedEqual(current, desired, arrayMeta) {
    if ((0, null_1.isNullOrUndefined)(current) && (0, null_1.isNullOrUndefined)(desired)) {
        return true;
    }
    if (!arrayMeta) {
        arrayMeta = {};
    }
    return equal(current, desired, '', arrayMeta);
}
exports.isDefaultedEqual = isDefaultedEqual;
//# sourceMappingURL=defaulted-equal.js.map