export type GenericHeapComparer<T> = (a: T, b: T) => boolean;
export declare class GenericHeap<T> {
    private _heap;
    private _comparer;
    constructor(comparer: GenericHeapComparer<T>, items?: T[]);
    get isEmpty(): boolean;
    get size(): number;
    get length(): number;
    peek(): T | null;
    get rawHeap(): T[];
    insert(item: T): void;
    pop(): T | null;
    print(): void;
    /*****/
    private _parent;
    private _left;
    private _right;
    private _hasLeft;
    private _hasRight;
    private _swap;
}
export declare class MinHeap extends GenericHeap<number> {
    constructor(items?: number[]);
}
export declare class MaxHeap extends GenericHeap<number> {
    constructor(items?: number[]);
}
interface PriorityQueueNode<T> {
    priority: number;
    value: T;
}
export declare class HeapPriorityQueue<T> extends GenericHeap<PriorityQueueNode<T>> {
    constructor(items?: PriorityQueueNode<T>[]);
    populate(items: T[], priorityFunc: (item: T) => number): void;
}
export {};
//# sourceMappingURL=heap.d.ts.map