import * as _ from 'lodash';
import { DefaultedEquatorPropMeta } from './defaulted-equal';
interface LoDashMixins extends _.LoDashStatic {
    deepClean(o: any): any;
    replaceAll(str: string, search: string, replacement: string): string;
    isNullOrUndefined(obj: any): boolean;
    isNotNullOrUndefined(obj: any): boolean;
    fastDeepEqual(a: any, b: any): boolean;
    isDefaultedEqual(current: any, desired: any, arrayMeta?: Record<string, DefaultedEquatorPropMeta>): boolean;
    makeDict<T = any, V = any>(items: T[] | null, cbKey: (item: T) => string | number, cbValue: (item: T) => V): Record<string | number, V>;
    makeBoolDict(items: any[] | null): Record<string | number, boolean>;
    stableStringify(x: any): string;
    makeArray<V>(obj: Record<string, any> | null, valueCb: (key: string, value: any) => V, filterCb?: (key: string, value: any) => boolean): V[];
    makeBoolArray(obj: Record<string, any> | null): any[];
    randomElement<V>(obj?: V[]): V;
}
declare const mixedLodash: LoDashMixins;
export { Stack } from './stack';
export { Queue } from './queue';
export { PriorityQueue } from './priority-queue';
export { GenericHeap, MinHeap, MaxHeap, HeapPriorityQueue } from './heap';
export default mixedLodash;
//# sourceMappingURL=index.d.ts.map