export declare class Node<T> {
    value: T;
    left: Node<T> | null;
    right: Node<T> | null;
    constructor(value: T, left: Node<T> | null, right: Node<T> | null);
}
export type NodeHandler<T> = (value: T, node: Node<T>) => void;
export declare function traverseTreeInOrder<T>(node: Node<T> | null, handler: NodeHandler<T>): void;
export declare function traverseTreePreOrder<T>(node: Node<T> | null, handler: NodeHandler<T>): void;
export declare function traverseTreePostOrder<T>(node: Node<T> | null, handler: NodeHandler<T>): void;
export declare function depthFirstSearch<T>(node: Node<T> | null, target: T): Node<T> | null;
//# sourceMappingURL=tree.d.ts.map