"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.depthFirstSearch = exports.traverseTreePostOrder = exports.traverseTreePreOrder = exports.traverseTreeInOrder = exports.Node = void 0;
var Node = /** @class */ (function () {
    function Node(value, left, right) {
        this.value = value;
        this.left = left !== null && left !== void 0 ? left : null;
        this.right = right !== null && right !== void 0 ? right : null;
    }
    return Node;
}());
exports.Node = Node;
function traverseTreeInOrder(node, handler) {
    if (node == null) {
        return;
    }
    traverseTreeInOrder(node.left, handler);
    handler(node.value, node);
    traverseTreeInOrder(node.right, handler);
}
exports.traverseTreeInOrder = traverseTreeInOrder;
function traverseTreePreOrder(node, handler) {
    if (node == null) {
        return;
    }
    handler(node.value, node);
    traverseTreeInOrder(node.left, handler);
    traverseTreeInOrder(node.right, handler);
}
exports.traverseTreePreOrder = traverseTreePreOrder;
function traverseTreePostOrder(node, handler) {
    if (node == null) {
        return;
    }
    traverseTreeInOrder(node.left, handler);
    traverseTreeInOrder(node.right, handler);
    handler(node.value, node);
}
exports.traverseTreePostOrder = traverseTreePostOrder;
function depthFirstSearch(node, target) {
    if (!node)
        return null;
    if (node.value === target)
        return node;
    var left = depthFirstSearch(node.left, target);
    if (left != null)
        return left;
    var right = depthFirstSearch(node.right, target);
    return right;
}
exports.depthFirstSearch = depthFirstSearch;
//# sourceMappingURL=tree.js.map