import { Options } from './options';
import { LogLevel } from './levels';
import { RootLogger } from './root';
import { ILogger } from './ilogger';
import { DumpWriter } from './dump-writer';
declare class BaseLogger {
    private _root;
    private _name;
    protected _logFile: string | null;
    private _level;
    private _options;
    constructor(root: RootLogger, name: string);
    get name(): string;
    get level(): LogLevel;
    get options(): Options;
    setup(options: Options): void;
    sublogger(name: string): ILogger;
    _implInit(): void;
    flush(): void;
    outputStream(fileName: string): DumpWriter | null;
    outputFile(fileName: string, contents: any): Promise<void>;
}
export { BaseLogger };
//# sourceMappingURL=base.d.ts.map