"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LogLevel = exports.LoggerOptions = exports.RootLogger = exports.DumpWriter = exports.setupLogger = exports.setupRootLogger = void 0;
const root_1 = require("./root");
Object.defineProperty(exports, "RootLogger", { enumerable: true, get: function () { return root_1.RootLogger; } });
const options_1 = require("./options");
Object.defineProperty(exports, "LoggerOptions", { enumerable: true, get: function () { return options_1.OptionsBuilder; } });
const dump_writer_1 = require("./dump-writer");
Object.defineProperty(exports, "DumpWriter", { enumerable: true, get: function () { return dump_writer_1.DumpWriter; } });
function setupRootLogger(name, options) {
    let optionsObj;
    if (options) {
        optionsObj = options.build();
    }
    var rootLogger = new root_1.RootLogger(name, optionsObj);
    return rootLogger;
}
exports.setupRootLogger = setupRootLogger;
function setupLogger(name, options) {
    const rootLogger = setupRootLogger(name, options);
    return rootLogger.logger;
}
exports.setupLogger = setupLogger;
var levels_1 = require("./levels");
Object.defineProperty(exports, "LogLevel", { enumerable: true, get: function () { return levels_1.LogLevel; } });
//# sourceMappingURL=index.js.map