"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OptionsBuilder = exports.Options = void 0;
const levels_1 = require("./levels");
class Options {
    constructor() {
        this.pretty = false;
        this.enableFile = false;
        this.cleanOnStart = false;
        this.level = levels_1.LogLevel.info;
        this.subLevels = {};
    }
}
exports.Options = Options;
class OptionsBuilder {
    constructor() {
        this._options = new Options();
    }
    pretty(value) {
        this._options.pretty = value;
        return this;
    }
    enableFile(value) {
        this._options.enableFile = value;
        return this;
    }
    path(value) {
        this._options.path = value;
        return this;
    }
    cleanOnStart(value) {
        this._options.cleanOnStart = value;
        return this;
    }
    level(value) {
        this._options.level = value;
        return this;
    }
    subLevel(name, value) {
        this._options.subLevels[name] = value;
        return this;
    }
    build() {
        return this._options;
    }
}
exports.OptionsBuilder = OptionsBuilder;
//# sourceMappingURL=options.js.map