import { MapperFunction, CExecuteOptions, Resolvable } from './index';
interface ItemInfo<T> {
    item: T;
    index: number;
    errors: number;
    lastError?: any;
    lastFailureMoment?: Date;
    delay: number | null;
}
export declare class Executor<T, R> {
    origItems: ItemInfo<T>[];
    items: ItemInfo<T>[];
    processing: Record<number, ItemInfo<T>>;
    action: MapperFunction<T, R>;
    options: CExecuteOptions;
    results: R[];
    rootResolve?: (thenableOrResult: Resolvable<R[]>) => void;
    rootReject?: (error?: any) => void;
    isProcessingFailed: boolean;
    waitingCoolDown: boolean;
    pauseTillNextTry?: number;
    constructor(items: T[], action: MapperFunction<T, R>, options: CExecuteOptions);
    get unfinishedCount(): number;
    execute(): Promise<R[]>;
    private _tryProcess;
    private _canProcessItem;
    private _processItem;
    private _handleItemFinished;
    private _handleItemFailed;
    private _finishSuccess;
    private _finishFailure;
    private _finish;
}
export {};
//# sourceMappingURL=executor.d.ts.map