"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MyPromise = exports.CRetryOptions = exports.CExecuteOptions = void 0;
var the_lodash_1 = __importDefault(require("the-lodash"));
var executor_1 = require("./executor");
var CExecuteOptions = /** @class */ (function () {
    function CExecuteOptions() {
        this.concurrency = 100;
        this.unlimitedRetries = false;
        this.retryCount = 0;
        this.coolDownOnFailure = false;
        this.initRetryDelay = 500;
        this.maxRetryDelay = 5000;
        this.retryDelayCoeff = 2.0;
        this.waitCompleteBeforeExit = false;
    }
    return CExecuteOptions;
}());
exports.CExecuteOptions = CExecuteOptions;
var CRetryOptions = /** @class */ (function () {
    function CRetryOptions() {
        this.unlimitedRetries = false;
        this.retryCount = 0;
        this.initRetryDelay = 0;
        this.maxRetryDelay = 0;
        this.retryDelayCoeff = 0;
        this.retryTimeout = 0;
        this.failureCount = 0;
    }
    return CRetryOptions;
}());
exports.CRetryOptions = CRetryOptions;
var MyPromise = /** @class */ (function () {
    function MyPromise() {
    }
    /*
     * Processes items in parallel
     */
    MyPromise.execute = function (items, action, options) {
        if (items == null || !items) {
            return Promise.resolve([]);
        }
        options = options || {};
        var myOptions = new CExecuteOptions();
        myOptions.concurrency = the_lodash_1.default.isNullOrUndefined(options.concurrency) ? 100 : options.concurrency;
        myOptions.concurrency = Math.max(1, myOptions.concurrency);
        myOptions.unlimitedRetries = the_lodash_1.default.isNullOrUndefined(options.unlimitedRetries) ? false : options.unlimitedRetries;
        myOptions.retryCount = the_lodash_1.default.isNullOrUndefined(options.retryCount) ? 0 : options.retryCount;
        myOptions.initRetryDelay = the_lodash_1.default.isNullOrUndefined(options.initRetryDelay) ? 500 : options.initRetryDelay;
        myOptions.maxRetryDelay = the_lodash_1.default.isNullOrUndefined(options.maxRetryDelay) ? 5000 : options.maxRetryDelay;
        myOptions.retryDelayCoeff = the_lodash_1.default.isNullOrUndefined(options.retryDelayCoeff) ? 2.0 : options.retryDelayCoeff;
        if (!the_lodash_1.default.isNullOrUndefined(options.coolDownOnFailure)) {
            myOptions.coolDownOnFailure = options.coolDownOnFailure;
        }
        if (!the_lodash_1.default.isNullOrUndefined(options.waitCompleteBeforeExit)) {
            myOptions.waitCompleteBeforeExit = options.waitCompleteBeforeExit;
        }
        var executor = new executor_1.Executor(items, action, myOptions);
        return executor.execute();
    };
    /*
     * Processes items in parallel
     */
    MyPromise.parallel = function (items, action) {
        if (!items) {
            return Promise.resolve([]);
        }
        return Promise.all(items.map(function (x) { return action(x); }));
    };
    /*
     * Processes items in sequence
     */
    MyPromise.serial = function (items, action) {
        return MyPromise.execute(items, action, {
            concurrency: 0,
            unlimitedRetries: false,
            retryCount: 0,
        });
    };
    MyPromise.try = function (action) {
        return __awaiter(this, void 0, void 0, function () {
            var res, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, action()];
                    case 1:
                        res = _a.sent();
                        return [2 /*return*/, res];
                    case 2:
                        err_1 = _a.sent();
                        throw err_1;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /*
     * Simple retry logic
     */
    MyPromise.retry = function (action, options) {
        options = options || {};
        var myOptions = new CRetryOptions();
        myOptions.unlimitedRetries = the_lodash_1.default.isNullOrUndefined(options.unlimitedRetries) ? false : options.unlimitedRetries;
        myOptions.retryCount = the_lodash_1.default.isNullOrUndefined(options.retryCount) ? 3 : options.retryCount;
        myOptions.initRetryDelay = the_lodash_1.default.isNullOrUndefined(options.initRetryDelay) ? 500 : options.initRetryDelay;
        myOptions.maxRetryDelay = the_lodash_1.default.isNullOrUndefined(options.maxRetryDelay) ? 5000 : options.maxRetryDelay;
        myOptions.retryDelayCoeff = the_lodash_1.default.isNullOrUndefined(options.retryDelayCoeff) ? 2.0 : options.retryDelayCoeff;
        myOptions.canContinueCb = the_lodash_1.default.isNullOrUndefined(options.canContinueCb) ? undefined : options.canContinueCb;
        myOptions.failureCount = 0;
        myOptions.retryTimeout = myOptions.initRetryDelay;
        return MyPromise._promiseRetryLoop(action, myOptions);
    };
    MyPromise._promiseRetryLoop = function (action, options) {
        return MyPromise.try(action).catch(function (reason) {
            return MyPromise._promiseRetryHandleFailure(reason, action, options);
        });
    };
    MyPromise._promiseRetryHandleFailure = function (reason, action, options) {
        options.failureCount++;
        if (options.unlimitedRetries ||
            options.failureCount <= options.retryCount) {
            if (options.canContinueCb) {
                return MyPromise.try(function () {
                    return options.canContinueCb(reason);
                })
                    .catch(function (reason) {
                    return MyPromise._promiseRetryHandleFailure(reason, action, options);
                })
                    .then(function (result) {
                    if (result) {
                        return MyPromise._promiseRetryWithTimeout(action, options);
                    }
                    else {
                        throw reason;
                    }
                });
            }
            options.retryTimeout = Math.min(options.retryTimeout * options.retryDelayCoeff, options.maxRetryDelay);
            return MyPromise._promiseRetryWithTimeout(action, options);
        }
        throw reason;
    };
    MyPromise._promiseRetryWithTimeout = function (action, options) {
        return MyPromise.timeout(options.retryTimeout).then(function () { return MyPromise._promiseRetryLoop(action, options); });
    };
    /*
     * Returns a promise which resolves in specified time delay
     */
    MyPromise.delay = function (timeoutMs) {
        if (!timeoutMs) {
            return Promise.resolve();
        }
        return MyPromise.construct(function (fulfill, reject) {
            setTimeout(function () {
                fulfill();
            }, timeoutMs);
        }).then(function () { return Promise.resolve(); });
    };
    /*
     * Returns a promise which resolves in specified time delay
     */
    MyPromise.timeout = function (timeoutMs) {
        return MyPromise.delay(timeoutMs);
    };
    /*
     * Creates a new Promise
     */
    MyPromise.construct = function (callback) {
        return new Promise(function (resolve, reject) {
            return callback(resolve, reject);
        });
    };
    return MyPromise;
}());
exports.MyPromise = MyPromise;
//# sourceMappingURL=promise.js.map